SystemOrganization addCategory: #'XPath-Core'!
SystemOrganization addCategory: 'XPath-Core-DOM'!
SystemOrganization addCategory: 'XPath-Core-Exceptions'!
SystemOrganization addCategory: 'XPath-Core-Functions'!
SystemOrganization addCategory: 'XPath-Core-Parsers'!
SystemOrganization addCategory: 'XPath-Core-Streams'!

!XMLComment methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

XMLException subclass: #XPathException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathException commentStamp: 'monty 12/20/2014 19:26' prior: 0!
A base class for XPath exceptions.!

XPathException subclass: #XPathArgumentNumberException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathArgumentNumberException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for function calls with the wrong number of arguments.!

!XPathException methodsFor: 'appending' stamp: 'monty 1/6/2015 09:24'!
appendPosition: aPosition
	self
		append: aPosition
		withDescription: 'at pos.'! !

XPathException subclass: #XPathSyntaxException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathSyntaxException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for syntax errors in XPath expressions.!

XPathException subclass: #XPathTypeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathTypeException commentStamp: 'monty 1/18/2015 13:55' prior: 0!
Invoked for type conversion errors.!

XPathException subclass: #XPathUndeclaredFunctionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredFunctionException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared functions.!

XPathException subclass: #XPathUndeclaredPrefixException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredPrefixException commentStamp: 'monty 3/5/2015 04:31' prior: 0!
Invoked for undeclared namespace prefixes used in name tests (only when one or more namespaces are set in the context object).!

XPathException subclass: #XPathUndeclaredVariableException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredVariableException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared variables.!

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/16/2015 14:25'!
% aNodeTestStringOrBlock
	"parent axis"
	(self hasParent
		and: [aNodeTestStringOrBlock asNodeTestBlock value: self parent])
		ifTrue: [^ self newNodeSetWith: self parent]
		ifFalse: [^ self newNodeSet]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 19:06'!
%% aNodeTestStringOrBlock
	"ancestor axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self ancestorNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 19:06'!
%%~ aNodeTestStringOrBlock
	"ancestor-or-self axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	(nodeTestBlock value: self)
		ifTrue: [nodeSet addLast: self].
	self ancestorNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 00:34'!
/ aNodeTestStringOrBlock
	"child axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 00:34'!
// aNodeTestStringOrBlock
	"descendant axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 00:34'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	(aNodeTestStringOrBlock asNodeTestBlock value: self)
		ifTrue: [^ self newNodeSetWith: self]
		ifFalse: [^ self newNodeSet]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 19:06'!
<< aNodeTestStringOrBlock
	"preceding axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self precedingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/10/2015 01:13'!
<<< aNodeTestStringOrBlock
	"preceding-sibling axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self precedingSiblingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathLevelReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 18:43'!
>> aNodeTestStringOrBlock
	"following axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self followingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/10/2015 01:12'!
>>> aNodeTestStringOrBlock
	"following-sibling axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self followingSiblingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathLevelDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/3/2015 00:44'!
@ aNodeTestStringOrBlock
	"attribute axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/3/2015 00:44'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:18'!
allNodesReverseDo: aBlock
	aBlock value: self! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/13/2015 21:15'!
ancestorOrSelfChildOfParent: aParent
	self parent = aParent
		ifTrue: [^ self].
	self parent = aParent parent
		ifTrue: [^ nil].
	self ancestorNodesDo: [:each |
		(each parent = aParent)
			ifTrue: [^ each]].
	^ nil.! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:09'!
defaultContextPosition
	self hasParent
		ifTrue: [^ self parent nodes indexOf: self]
		ifFalse: [^ 1]! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:05'!
defaultContextSize
	self hasParent
		ifTrue: [^ self parent nodes size]
		ifFalse: [^ 1]! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 18:54'!
documentRoot
	"returns the root of the DOM tree, a document node if there is one or the
	last ancestor or self otherwise"
	| documentRoot |

	documentRoot := self.
	self ancestorNodesDo: [:each | documentRoot := each].
	^ documentRoot.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [each allNodesDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:38'!
hasExpandedName
	^ false! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ false! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ false! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 12/30/2014 06:49'!
newNodeSet
	^ XPathNodeSet new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/3/2015 01:35'!
newNodeSetWith: aNode
	^ XPathNodeSet with: aNode! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 3/4/2015 11:06'!
occursInDocumentBeforeNode: aNode
	| selfAncestors aNodeAncestors selfLastAncestor aNodeLastAncestor selfAncestorOffset aNodeAncestorOffset |

	self = aNode
		ifTrue: [^ false].

	"handle easy cases where one is a root or one is the parent of the other
	or they share parents"
	(self hasParent not
		or: [aNode parent = self])
		ifTrue: [^ true].
	(aNode hasParent not
		or: [self parent = aNode])
		ifTrue: [^ false].
	self parent = aNode parent
		ifTrue: [^ self occursInParentBeforeNode: aNode].

	selfAncestors := OrderedCollection new.
	self ancestorNodesDo: [:each |
		each = aNode
			ifTrue: [^ false].
		selfAncestors addLast: each].

	aNodeAncestors := OrderedCollection new.
	aNode ancestorNodesDo: [:each |
		each = self
			ifTrue: [^ true].
		aNodeAncestors addLast: each].

	selfAncestorOffset := (selfAncestors size - aNodeAncestors size) max: 0.
	selfLastAncestor := selfAncestors at: selfAncestorOffset ifAbsent: [self].
	aNodeAncestorOffset := (aNodeAncestors size - selfAncestors size) max: 0.
	aNodeLastAncestor := aNodeAncestors at: aNodeAncestorOffset ifAbsent: [aNode].
	1
		to: selfAncestors size - selfAncestorOffset
		do: [:i | | selfAncestor aNodeAncestor |
			selfAncestor := selfAncestors at: i + selfAncestorOffset.
			aNodeAncestor := aNodeAncestors at: i + aNodeAncestorOffset.
			selfAncestor = aNodeAncestor
				ifTrue: [^ selfLastAncestor occursInParentBeforeNode: aNodeLastAncestor].

			selfLastAncestor := selfAncestor.
			aNodeLastAncestor := aNodeAncestor].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 1/30/2015 15:24'!
occursInParentAfterAttribute: anAttribute
	^ true! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 20:44'!
occursInParentAfterNamespace: aNamespaceNode
	^ true! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/3/2015 14:51'!
occursInParentAfterSibling: aNode
	self parent nodesDo: [:each |
		each = aNode
			ifTrue: [^ true].
		each = self
			ifTrue: [^ false]].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 1/30/2015 15:25'!
occursInParentBeforeNode: aNode
	^ aNode occursInParentAfterSibling: self! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [each allNodesReverseDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"returns XPath node string-value"
	 ^ ''! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/12/2015 20:28'!
xPath: anXPathOrXPathString
	^ anXPathOrXPathString asXPath in: self! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/12/2015 20:40'!
xPath: anXPathOrXPathString context: aContext
	^ anXPathOrXPathString asXPath
		in: self
		context: aContext! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 1/30/2015 02:55'!
~ aNameOrBlock
	"self axis"
	((aNameOrBlock asNodeTestBlock value: self)
		ifTrue: [^ self newNodeSetWith: self]
		ifFalse: [^ self newNodeSet])! !

XMLNode subclass: #XPathNamespaceNode
	instanceVariableNames: 'name uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNamespaceNode commentStamp: 'monty 2/10/2015 03:34' prior: 0!
This class models an element namespace mapping as a DOM node for compatibility with the XPath standard.!

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/22/2015 02:55'!
element: anElement name: aPrefix uri: aURI
	^ self new
		setElement: anElement
		name: aPrefix
		uri: aURI! !

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/10/2015 13:50'!
withXMLNamespaceOnElement: anElement
	^ self
		element: anElement
		name: 'xml'
		uri: XMLNamespaceScope xmlNamespaceURI! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 3/10/2015 13:52'!
= anObject
	"This is needed because namespace nodes are not part of the DOM
	tree and are created dynamically by XPath, so unless = is defined
	the union of two node sets could contain duplicate namespace nodes
	for the same namespace of the same element"

	self == anObject
		ifTrue: [^ true].

	self class == anObject class
		ifFalse: [^ false].

	"elements don't share namespace nodes according to the spec"
	^ self element = anObject element
		and: [self name = anObject name
			and: [self uri = anObject uri]].! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/26/2015 22:10'!
defaultContextPosition
	self hasParent
		ifTrue: [^ self parent namespaceNodes indexOf: self]
		ifFalse: [^ 1]! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/26/2015 22:08'!
defaultContextSize
	self hasParent
		ifTrue: [^ self parent namespaceNodes size]
		ifFalse: [^ 1]! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:22'!
element
	^ parent! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 12/28/2014 06:21'!
expandedName
	^ self localName expandWithNamespaceURI: self namespaceURI! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 2/28/2015 14:13'!
hasNamespaceURI
	^ false! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 3/10/2015 14:12'!
hasPrefix
	"this returns true only if the name is prefixed, and namespace
	names cannot be prefixed"
	^ false! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	^ false! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 3/10/2015 13:52'!
hash
	^ self name hash bitXor: self uri hash! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ true! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ true! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
localName
	^ self name! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
name
	^ name ifNil: [name := '']! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 3/10/2015 14:14'!
namespaceURI
	"spec says namespace nodes cannot be namespaced
	(the namespace part of the expanded name is null)"
	^ ''! !

!XPathNamespaceNode methodsFor: 'private' stamp: 'monty 1/30/2015 15:24'!
occursInParentAfterAttribute: anAttribute
	^ false! !

!XPathNamespaceNode methodsFor: 'private' stamp: 'monty 3/25/2015 20:44'!
occursInParentAfterNamespace: aNamespaceNode
	self parent namespaceNodesDo: [:each |
		each = aNamespaceNode
			ifTrue: [^ true].
		each = self
			ifTrue: [^ false]].
	^ false.! !

!XPathNamespaceNode methodsFor: 'private' stamp: 'monty 1/30/2015 15:25'!
occursInParentBeforeNode: aNode
	^ aNode occursInParentAfterNamespace: self! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 3/10/2015 14:08'!
prefix
	"the name of a namespace node cannot be prefixed"
	^ ''! !

!XPathNamespaceNode methodsFor: 'initialization' stamp: 'monty 3/22/2015 02:55'!
setElement: anElement name: aPrefix uri: aURI
	"reuse parent inst var, like in XMLAttribute"
	parent := anElement.
	name := aPrefix.
	uri := aURI.! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self uri! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 1/26/2015 20:32'!
uri
	^ uri ifNil: [uri := '']! !

!XPathNamespaceNode methodsFor: 'printing' stamp: 'monty 3/10/2015 13:53'!
writeXMLOn: aWriter
	aWriter
		writeName:
			(self name
				ifEmpty: ['xmlns']
				ifNotEmpty: ['xmlns:', self name])
		escapedContentValue: self uri! !

!XMLElement methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/10/2015 01:04'!
@ aNodeTestStringOrBlock
	"attribute axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self hasAttributes
		ifTrue: [
			self attributeNodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XMLElement methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/10/2015 01:04'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self hasNamespaceNodes
		ifTrue: [
			self namespaceNodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 2/9/2015 22:23'!
hasNamespaceNodes
	"elements have at least one node for the default xml namespace"
	^ self usesNamespaces! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	^ self hasPrefix
		and: [self namespaceURI = aURI]! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ true! !

!XMLElement methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:07'!
namespaceNodes
	| namespaceNodes |

	namespaceNodes := self newListForSelect.
	self namespaceNodesDo: [:each | namespaceNodes addLast: each].
	^ namespaceNodes.! !

!XMLElement methodsFor: '*XPath-Core-enumerating' stamp: 'monty 3/26/2015 23:29'!
namespaceNodesDo: aBlock
	"every element has a node for the default xml namespace.
	if it isn't explicitly defined, then it's first in order"
	self usesNamespaces
		ifFalse: [^ self].

	(self hasNamespaces
		and: [self namespaceScope includesPrefix: 'xml'])
		ifFalse: [aBlock value: (XPathNamespaceNode withXMLNamespaceOnElement: self)].

	self hasNamespaces
		ifTrue: [
			self namespaceScope prefixesAndURIsDo: [:prefix :uri |
				aBlock value:
					(XPathNamespaceNode
						element: self
						name: prefix
						uri: uri)]].! !

!Number class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 02:01'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanNumber: self)
		or: [anObject xPathEqualsNumber: self]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanNumber: self)
		or: [anObject xPathEqualsNumber: self]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 12/22/2014 18:16'!
asXPathBoolean
	^ (self isZero or: [self isNaN]) not! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 12/23/2014 14:40'!
asXPathNumber
	^ self asFloat! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 08:50'!
asXPathString
	self isNaN
		ifTrue: [^ 'NaN'].
	self isZero
		ifTrue: [^ '0'].
	self isInfinite
		ifTrue: [
			self < 0
				ifTrue: [^ '-Infinity']
				ifFalse: [^ 'Infinity']].
	"overridden in gemstone version to use greaseString"
	^ self printString.! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:54'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self = each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:39'!
xPathEqualsNumber: aNumber
	^ self = aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:46'!
xPathEqualsString: aString
	^ self = aString asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:48'!
xPathGreaterThanBoolean: aBoolean
	^ self > aBoolean asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathGreaterThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self > each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:39'!
xPathGreaterThanNumber: aNumber
	^ self > aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:48'!
xPathGreaterThanString: aString
	^ self > aString asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:00'!
xPathLessThanBoolean: aBoolean
	^ self < aBoolean asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathLessThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self < each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:57'!
xPathLessThanNumber: aNumber
	^ self < aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:57'!
xPathLessThanString: aString
	^ self < aString asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:54'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathNotEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self ~= each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:54'!
xPathNotEqualsNumber: aNumber
	^ self ~= aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:55'!
xPathNotEqualsString: aString
	^ self ~= aString asXPathNumber! !

!XMLAttribute methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:09'!
defaultContextPosition
	self hasParent
		ifTrue: [^ self parent attributeNodes indexOf: self]
		ifFalse: [^ 1]! !

!XMLAttribute methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:06'!
defaultContextSize
	self hasParent
		ifTrue: [^ self parent attributeNodes size]
		ifFalse: [^ 1]! !

!XMLAttribute methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLAttribute methodsFor: '*XPath-Core-testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	"unprefixed attributes cannot be namespaced"
	^ self namespaceURI = aURI! !

!XMLAttribute methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ true! !

!XMLAttribute methodsFor: '*XPath-Core-private' stamp: 'monty 3/3/2015 15:49'!
occursInParentAfterAttribute: anAttribute
	self element attributeNodesDo: [:each |
		each = anAttribute
			ifTrue: [^ true].
		each = self
			ifTrue: [^ false]].
	^ false.! !

!XMLAttribute methodsFor: '*XPath-Core-private' stamp: 'monty 1/30/2015 15:25'!
occursInParentBeforeNode: aNode
	^ aNode occursInParentAfterAttribute: self! !

!XMLAttribute methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self value! !

!String class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathString! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 02:01'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanString: self)
		or: [anObject xPathEqualsString: self]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanString: self)
		or: [anObject xPathEqualsString: self]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 3/25/2015 21:42'!
asNodeTestBlock
	"parses string as a node test to produce a node test block"
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler new) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/17/2014 14:19'!
asXPath
	^ XPath for: self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self notEmpty! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/24/2014 19:19'!
asXPathNumber
	^ [Float readFrom: self readStream]
		on: Error
		do: [:error | Float nan]! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 15:06'!
asXPathString
	^ self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:03'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self = each stringValue]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:54'!
xPathEqualsNumber: aNumber
	^ self asXPathNumber = aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:52'!
xPathEqualsString: aString
	^ self = aString! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:04'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathNumber > aBoolean asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathGreaterThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number > each stringValue asXPathNumber].! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:05'!
xPathGreaterThanNumber: aNumber
	^ self asXPathNumber > aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:04'!
xPathGreaterThanString: aString
	^ self asXPathNumber > aString asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:05'!
xPathLessThanBoolean: aBoolean
	^ self asXPathNumber < aBoolean asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathLessThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number < each stringValue asXPathNumber].! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:06'!
xPathLessThanNumber: aNumber
	^ self asXPathNumber < aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:06'!
xPathLessThanString: aString
	^ self asXPathNumber < aString asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:03'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathNotEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self ~= each stringValue]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:02'!
xPathNotEqualsNumber: aNumber
	^ self asXPathNumber ~= aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:02'!
xPathNotEqualsString: aString
	^ self ~= aString! !

!PositionableStream methodsFor: '*XPath-Core-converting' stamp: 'monty 1/14/2015 03:20'!
asXPathReadStreamAdapter
	^ XPathReadStreamAdapter on: self! !

!BlockClosure methodsFor: '*XPath-Core' stamp: 'monty 12/31/2014 08:17'!
asNodeTestBlock
	^ self! !

Collection subclass: #XPathFunctionSet
	instanceVariableNames: 'functionsByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFunctionSet commentStamp: 'monty 2/10/2015 03:01' prior: 0!
A set for XPath functions. Supports set composition with + and - and lookup of functions by name.
!

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 3/8/2015 11:44'!
default
	^ XPathBooleanFunction +
		XPathCeilingFunction +
		XPathConcatFunction +
		XPathContainsFunction +
		XPathCountFunction +
		XPathEndsWithFunction +
		XPathFalseFunction +
		XPathFloorFunction +
		XPathIDFunction +
		XPathLangFunction +
		XPathLocalNameFunction +
		XPathNameFunction +
		XPathNamespaceURIFunction +
		XPathNormalizeSpaceFunction +
		XPathNotFunction +
		XPathNumberFunction +
		XPathRoundFunction +
		XPathStartsWithFunction +
		XPathStringFunction +
		XPathStringLengthFunction +
		XPathSubstringAfterFunction +
		XPathSubstringBeforeFunction +
		XPathSubstringFunction +
		XPathSumFunction +
		XPathTranslateFunction +
		XPathTrueFunction! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/18/2015 15:23'!
new
	^ self new: 15! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 12/27/2014 17:02'!
new: aCapacity
	^ self basicNew initialize: aCapacity! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/19/2015 15:16'!
newFrom: aCollection
	"for portability"
	^ self withAll: aCollection! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 12/27/2014 17:09'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetWithFunctions: self! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 3/3/2015 04:30'!
, aCollection
	", is not defined for non-sequenceable collections on gemstone"
	^ self copy
		addAll: aCollection;
		yourself! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 12/29/2014 21:31'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetSubtractedFromFunctions: self! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 12/29/2014 21:18'!
= aFunctionSet
	self == aFunctionSet
		ifTrue: [^ true].

	(self class == aFunctionSet class
		and: [self size = aFunctionSet size])
		ifFalse: [^ false].

	^ self allSatisfy: [:each | aFunctionSet includes: each].! !

!XPathFunctionSet methodsFor: 'adding' stamp: 'monty 12/27/2014 16:56'!
add: aFunction
	^ functionsByName
		at: aFunction functionName
		put: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 1/15/2015 09:51'!
asFunctionSet
	^ self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 1/15/2015 09:53'!
asFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 12/29/2014 21:31'!
asFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 12/29/2014 21:22'!
asFunctionSetWithFunction: aFunction
	^ self copyWith: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/3/2015 04:18'!
asFunctionSetWithFunctions: aFunctionSet
	^ self, aFunctionSet! !

!XPathFunctionSet methodsFor: 'enumerating' stamp: 'monty 12/27/2014 16:59'!
do: aBlock
	functionsByName valuesDo: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 2/10/2015 19:11'!
functionNamed: aFunctionName
	^  functionsByName at: aFunctionName! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 2/10/2015 19:12'!
functionNamed: aFunctionName ifAbsent: aBlock
	^  functionsByName
		at: aFunctionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'private' stamp: 'monty 1/19/2015 17:08'!
functionsByName
	^ functionsByName! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 12/29/2014 21:19'!
hash
	^ functionsByName hash! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 12/27/2014 17:10'!
includes: aFunction
	^ (functionsByName
		at: aFunction functionName
		ifAbsent: [^ false]) == aFunction! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 2/10/2015 19:15'!
includesFunctionNamed: aName
	^ functionsByName includesKey: aName! !

!XPathFunctionSet methodsFor: 'initialization' stamp: 'monty 12/27/2014 17:01'!
initialize: aCapacity
	functionsByName := Dictionary new: aCapacity! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 12/27/2014 03:55'!
postCopy
	functionsByName := functionsByName copy! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 12/27/2014 16:58'!
remove: aFunction ifAbsent: aBlock
	^ functionsByName
		removeKey: aFunction functionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:59'!
size
	^ functionsByName size! !

!XMLDocument methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 18:55'!
documentRoot
	"returns the root of the DOM tree"
	^ self! !

!XMLDocument methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 20:45'!
occursInParentAfterAttribute: anAttribute
	^ false! !

!XMLDocument methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 20:44'!
occursInParentAfterNamespace: aNamespaceNode
	^ false! !

!XMLDocument methodsFor: '*XPath-Core-private' stamp: 'monty 1/30/2015 15:26'!
occursInParentAfterSibling: aNode
	^ false! !

!Boolean class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 02:00'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanBoolean: self)
		or: [anObject xPathEqualsBoolean: self]! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanBoolean: self)
		or: [anObject xPathEqualsBoolean: self]! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:29'!
asXPathNumber
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: [1.0]
		ifFalse: [0.0]! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:28'!
asXPathString
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: ['true']
		ifFalse: ['false']! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 06:16'!
xPathEqualsBoolean: aBoolean
	^ self = aBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/25/2014 15:41'!
xPathEqualsNodeSet: aNodeSet
	^ self = aNodeSet asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 06:16'!
xPathEqualsNumber: aNumber
	^ self = aNumber asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 06:17'!
xPathEqualsString: aString
	^ self = aString asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:17'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathNumber > aBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:18'!
xPathGreaterThanNodeSet: aNodeSet
	^ self asXPathNumber > aNodeSet asXPathBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:42'!
xPathGreaterThanNumber: aNumber
	^ self asXPathNumber > aNumber asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:46'!
xPathGreaterThanString: aString
	^ self asXPathNumber > aString asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:00'!
xPathLessThanBoolean: aBoolean
	^ self asXPathNumber < aBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:18'!
xPathLessThanNodeSet: aNodeSet
	^ self asXPathNumber < aNodeSet asXPathBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:46'!
xPathLessThanNumber: aNumber
	^ self asXPathNumber < aNumber asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:46'!
xPathLessThanString: aString
	^ self asXPathNumber < aString asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:36'!
xPathNotEqualsBoolean: aBoolean
	^ self ~= aBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:37'!
xPathNotEqualsNodeSet: aNodeSet
	^ self ~= aNodeSet asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:36'!
xPathNotEqualsNumber: aNumber
	^ self ~= aNumber asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:35'!
xPathNotEqualsString: aString
	^ self ~= aString asXPathBoolean! !

!XMLString methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 12/28/2014 06:21'!
expandedName
	^ self localName expandWithNamespaceURI: self namespaceURI! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 2/28/2015 14:13'!
hasNamespaceURI
	^ false! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:58'!
hasPrefix
	^ false! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	^ false! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:13'!
localName
	^ self name! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
name
	^ self target! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
namespaceURI
	"The spec says the namespace URI part of a PI expanded name is null"
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:05'!
prefix
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self data! !

XMLNodeList subclass: #XPathNodeSet
	instanceVariableNames: 'set sortOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSet commentStamp: 'monty 2/10/2015 03:47' prior: 0!
An XPath node set is an ordered node list that has no duplicates. Node sets produced by XPath expression evaluation will be sorted in either document order or reverse document order.!

!XPathNodeSet class methodsFor: 'private' stamp: 'monty 1/15/2015 13:52'!
errorCannotConvert: anObject
	XPathTypeException
		formatSignal: 'Cannot convert object of class {1} to node set'
		with: anObject class name! !

!XPathNodeSet class methodsFor: 'instance creation' stamp: 'monty 1/15/2015 13:51'!
xPathNewFrom: anObject
	"no conversions are specified from other types to node sets"
	(anObject isKindOf: XPathNodeSet)
		ifFalse: [self errorCannotConvert: anObject].
	^ anObject.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:18'!
% aNodeTestStringOrBlock
	"parent axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				parentAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first % aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
%% aNodeTestStringOrBlock
	"ancestor axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				ancestorAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first %% aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
%%~ aNodeTestStringOrBlock
	"ancestor-or-self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				ancestorOrSelfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first %%~ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
/ aNodeTestStringOrBlock
	"child axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				childAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first / aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
// aNodeTestStringOrBlock
	"descendant axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				descendantAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first // aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 02:03'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanNodeSet: self)
		or: [anObject xPathEqualsNodeSet: self]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanNodeSet: self)
		or: [anObject xPathEqualsNodeSet: self]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				descendantOrSelfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first //~ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
<< aNodeTestStringOrBlock
	"preceding axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				precedingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first << aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
<<< aNodeTestStringOrBlock
	"preceding-sibling axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				precedingSiblingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first <<< aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
>> aNodeTestStringOrBlock
	"following axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				followingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first >> aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
>>> aNodeTestStringOrBlock
	"following-sibling axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				followingSiblingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first >>> aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 01:17'!
?? aFilterBlockOrInteger
	"filters with three-argument filter block or index"
	| nodeSet contextSize |

	nodeSet := self copyEmpty.
	aFilterBlockOrInteger isNumber
		ifTrue: [
			(self
				at: aFilterBlockOrInteger rounded
				ifAbsent: [nil])
				ifNotNil: [:node | nodeSet addLast: node].
			^ nodeSet].

	contextSize := self size.
	1 to: contextSize do: [:i | | node result |
		node := self at: i.
		(result :=
			aFilterBlockOrInteger
				value: node
				value: i
				value: contextSize) isNumber
			ifTrue: [
				result rounded = i
					ifTrue: [nodeSet addLast: node]]
			ifFalse: [
				result asXPathBoolean
					ifTrue: [nodeSet addLast: node]]].

	^ nodeSet sortOrderFrom: self.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
@ aNodeTestStringOrBlock
	"attribute axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				attributeAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first @ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				namespaceAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first @@ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 23:31'!
afterAdding: aNode at: anIndex
	| oldSize |

	oldSize := self set size.
	((self set
		add: aNode;
		size) > oldSize)
		ifFalse: [self movedNode: aNode to: anIndex].
	sortOrder := nil.
	super
		afterAdding: aNode
		at: anIndex.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 23:33'!
afterAddingLast: aNode
	| oldSize |

	oldSize := self set size.
	(self set
		add: aNode;
		size) > oldSize
		ifFalse: [self movedNode: aNode to: oldSize].
	sortOrder := nil.
	super afterAddingLast: aNode.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/24/2015 10:49'!
afterRemoving: aNode
	self set remove: aNode.
	"removing does not change order"
	super afterRemoving: aNode.! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathBoolean
	^ self notEmpty! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathNumber
	^ self asXPathString asXPathNumber! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 3/25/2015 20:44'!
asXPathString
	^ self firstInDocumentOrder
		ifNil: ['']
		ifNotNil: [:node | node stringValue]! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/13/2015 22:15'!
copy
	"copies that don't add or replace have same sort order"
	^ super copy sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2015 22:53'!
copyAfter: anObject
	"copies that don't add or replace have same sort order"
	^ (super copyAfter: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2015 22:53'!
copyAfterLast: anObject
	"copies that don't add or replace have same sort order"
	^ (super copyAfterLast: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/13/2015 22:14'!
copyFrom: aStartIndex to: anEndIndex
	"copies that don't add or replace have same sort order"
	^ (super
		copyFrom: aStartIndex
		to: anEndIndex) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/13/2015 22:14'!
copyUpTo: anObject
	"copies that don't add or replace have same sort order"
	^ (super copyUpTo: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/13/2015 22:15'!
copyUpToLast: anObject
	"copies that don't add or replace have same sort order"
	^ (super copyUpToLast: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/13/2015 22:15'!
copyWithout: anObject
	"copies that don't add or replace have same sort order"
	^ (super copyWithout: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/13/2015 22:15'!
copyWithoutAll: aCollection
	"copies that don't add or replace have same sort order"
	^ (super copyWithoutAll: aCollection) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrder
	^ self sortOrder firstInDocumentOrderFrom: self! !

!XPathNodeSet methodsFor: 'testing' stamp: 'monty 1/16/2015 05:26'!
includes: aNode
	^ self set includes: aNode! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/9/2015 01:31'!
movedNode: aNode to: anIndex
	| i |

	(i :=
		self
			indexOf: aNode
			otherThan: anIndex) > 0
		ifTrue: [
			"since a node is just being moved, the collection
			is changed directly without notifying observers"
			collection removeAt: i]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/13/2015 22:15'!
reject: aBlock
	"reject doesn't change sort order"
	^ (super reject: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 02:49'!
reverseInPlace
	self
		reverseInPlaceFrom: 1
		to: collection size! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 02:49'!
reverseInPlaceFrom: aStart to: anEnd
	| start end |

	start := aStart.
	end := anEnd.
	[start < end]
		whileTrue: [
			self swap: start with: end.
			start := start + 1.
			end := end - 1].! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 2/8/2015 03:00'!
reverseSort
	self sortOrder reverseDocumentOrderSort: self! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 2/10/2015 21:42'!
reverseSorted
	^ self copy reverseSort! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/5/2015 17:52'!
select: aBlock
	"select doesn't change sort order"
	^ (super select: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/18/2015 06:06'!
set
	"IdentitySet is not used because namespace nodes implement ="
	^ set ifNil: [set := Set new: 5]! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 1/26/2015 19:01'!
sort
	self sortOrder documentOrderSort: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/10/2015 01:12'!
sortOrder
	sortOrder
		ifNil: [
			self size > 1
				ifTrue: [sortOrder := XPathUnknownSortOrder new]
				ifFalse: [sortOrder := XPathLevelDocumentSortOrder new]].
	^ sortOrder.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/26/2015 17:48'!
sortOrder: aSortOrder
	sortOrder := aSortOrder! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 03:50'!
sortOrderFrom: aNodeSet
	sortOrder := aNodeSet sortOrder copy! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 3/27/2015 01:16'!
stringValues
	"returns XPath string-values of nodes"
	^ self collect: [:each | each stringValue]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 01:17'!
stringValuesDo: aBlock
	"enumerates XPath string-values of nodes"
	self do: [:each | aBlock value: each stringValue]! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 3/25/2015 23:26'!
swap: aFirstIndex with: aSecondIndex
	super
		swap: aFirstIndex
		with: aSecondIndex.

	sortOrder := nil.! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:04'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathEqualsNodeSet: aNodeSet
	| stringValues |

	stringValues := Set new: self size.
	self do: [:each | stringValues add: each stringValue].
	^ aNodeSet anySatisfy: [:node | stringValues includes: node stringValue].! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathEqualsNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber = aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathEqualsString: aString
	^ self anySatisfy: [:each | each stringValue = aString]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 12/25/2014 15:34'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathBoolean asXPathNumber > aBoolean asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathGreaterThanNodeSet: aNodeSet
	| least |

	aNodeSet do: [:each | | number |
		number := each stringValue asXPathNumber.
		(least isNil
			or: [number < least])
			ifTrue: [least := number]].
	^ least notNil
		and: [self anySatisfy: [:each | each stringValue asXPathNumber > least]].! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathGreaterThanNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber > aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathGreaterThanString: aString
	| number |

	number := aString asXPathNumber.
	^ self anySatisfy: [:each | each stringValue asXPathNumber > number]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:11'!
xPathLessThanBoolean: aBoolean
	^ self asXPathBoolean asXPathNumber < aBoolean asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathLessThanNodeSet: aNodeSet
	| greatest |

	aNodeSet do: [:each | | number |
		number := each stringValue asXPathNumber.
		(greatest isNil
			or: [number > greatest])
			ifTrue: [greatest := number]].
	^ greatest notNil
		and: [self anySatisfy: [:each | each stringValue asXPathNumber < greatest]].! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:41'!
xPathLessThanNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber < aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:23'!
xPathLessThanString: aString
	| number |

	number := aString asXPathNumber.
	^ self anySatisfy: [:each | each asXPathNumber < number]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:00'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:42'!
xPathNotEqualsNodeSet: aNodeSet
	| stringValues |

	"should return true according to spec when aNodeSet and self each have at least
	one node that don't have the same string-values"
	stringValues := self collect: [:each | each stringValue].
	aNodeSet do: [:node | | stringValue |
		stringValue := node stringValue.
		stringValues do: [:each |
			each = stringValue
				ifFalse: [^ true]]].
	^ false.! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:42'!
xPathNotEqualsNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber ~= aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 3/25/2015 19:42'!
xPathNotEqualsString: aString
	^ self anySatisfy: [:each | each stringValue ~= aString]! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2015 04:10'!
| aNodeSet
	"XPath node set union"
	^ self copy
		addAll: aNodeSet;
		sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
~ aNodeTestStringOrBlock
	"self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				selfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first ~ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:20'!
allNodesReverseDo: aBlock
	self hasChildren
		ifTrue: [self nodes reverseDo: [:each | each allNodesReverseDo: aBlock]].
	aBlock value: self.! !

!Object class methodsFor: '*XPath-Core' stamp: 'monty 1/20/2015 19:23'!
xPathNewFrom: anObject
	^ anObject! !

Object subclass: #XPath
	instanceVariableNames: 'xPathSource compiledXPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath commentStamp: 'monty 3/26/2015 00:14' prior: 0!
This class evaluates XPath expressions in the context of XMLNodes using optional context objects to control evaluation. It supports all XPath 1.0 syntax with extensions.

This is the usage:
	path := XPath for: anXPathString.
	result := path in: aNode.

or with one message:
	result := XPath for: anXPathString in: aNode.

A custom context can be set this way:
	path := XPath for: anXPathString.
	path
		in: aNode
		context:
			(XPathContext new
				variableAt: 'name' put: 'value';
				yourself)

or with one message:
	XPath
		for: anXPathString
		in: aNode
		context:
			(XPathContext new
				variableAt: 'name' put: 'value';
				yourself).

The syntax extensions supported are prefix wildcards in name tests like "*:name", attribute() and element() type tests that can contain embedded name tests like "element(prefix:name)", namespace() type tests, and the ability to match literal prefixes instead of the namespaces bound to them (See XPathContext for more information).

(Compiled XPaths are cached for performance.)!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath class methodsFor: 'accessing' stamp: 'monty 2/8/2015 19:29'!
clearCompiledXPathCache
	"self clearCompiledXPathCache"
	compiledXPathCache ifNotNil: [compiledXPathCache clear]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/20/2015 02:51'!
compiledXPathCache
	^ compiledXPathCache
		ifNil: [compiledXPathCache := XMLKeyValueCache maxSize: 512]! !

!XPath class methodsFor: 'private' stamp: 'monty 2/17/2015 08:55'!
compiledXPathCacheAt: anXPathSourceString ifAbsent: aBlock
	^ self compiledXPathCache
		at: anXPathSourceString
		ifAbsent: aBlock! !

!XPath class methodsFor: 'private' stamp: 'monty 2/17/2015 08:50'!
compiledXPathCacheAt: anXPathSourceString put: aCompiledXPath
	^ self compiledXPathCache
		at: anXPathSourceString
		put: aCompiledXPath! !

!XPath class methodsFor: 'instance creation' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString
	^ self new xPathSource: anXPathSourceString
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode
	^ (self for: anXPathSourceString) in: aNode
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode context: aContext
	^ (self for: anXPathSourceString)
		in: aNode
		context: aContext! !

!XPath class methodsFor: 'class initialization' stamp: 'monty 3/5/2015 18:03'!
initialize
	"self initialize"

	self clearCompiledXPathCache.! !

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:49'!
maxCachedCompiledXPaths
	^ self compiledXPathCache maxSize! !

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:50'!
maxCachedCompiledXPaths: anInteger
	self compiledXPathCache maxSize: anInteger! !

!XPath methodsFor: 'converting' stamp: 'monty 1/17/2015 04:38'!
asXPath
	^ self! !

!XPath methodsFor: 'compiling' stamp: 'monty 3/2/2015 15:33'!
compile
	^ self compileWith: self compilerClass new! !

!XPath methodsFor: 'compiling' stamp: 'monty 3/2/2015 15:33'!
compileWith: anXPathCompiler
	compiledXPath := anXPathCompiler compile: self xPathSource.
	self class
		compiledXPathCacheAt: self xPathSource
		put: compiledXPath.
	^ compiledXPath.! !

!XPath methodsFor: 'accessing' stamp: 'monty 3/2/2015 15:33'!
compiledXPath
	^ compiledXPath ifNil: [
		compiledXPath :=
			self class
				compiledXPathCacheAt: self xPathSource
				ifAbsent: [self compile]]! !

!XPath methodsFor: 'accessing' stamp: 'monty 12/22/2014 03:12'!
compilerClass
	^ XPathCompiler! !

!XPath methodsFor: 'accessing' stamp: 'monty 1/19/2015 08:26'!
contextClass
	^ XPathContext! !

!XPath methodsFor: 'evaluating' stamp: 'monty 2/13/2015 20:44'!
evaluate
	^ self in: nil! !

!XPath methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:09'!
in: aNode
	^ self
		in: aNode
		context: self contextClass new! !

!XPath methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:18'!
in: aNode context: aContext
	^ self compiledXPath
		value: aNode
		value: aContext! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource
	^ xPathSource! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource: anXPathSourceString
	xPathSource := anXPathSourceString! !

Object subclass: #XPathAxis
	instanceVariableNames: 'axisSpecifier isImplicit isStartOfRelativeLocationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathAxis commentStamp: 'monty 1/10/2015 01:54' prior: 0!
A class for storing the axis of a step while it is being parsed.!

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/13/2015 11:27'!
axisSpecifier
	^ axisSpecifier! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/13/2015 12:11'!
axisSpecifier: anAxisSpecifier
	axisSpecifier := anAxisSpecifier.
	isImplicit := false.! !

!XPathAxis methodsFor: 'handling' stamp: 'monty 1/14/2015 02:41'!
handleWith: aHandler
	self isStartOfRelativeLocationPath
		ifTrue: [aHandler handleStartRelativeLocationPath].
	aHandler handleAxisSpecifier: self axisSpecifier.
	self reset.! !

!XPathAxis methodsFor: 'initialization' stamp: 'monty 2/13/2015 20:47'!
initialize
	super initialize.
	self reset.! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 1/13/2015 11:27'!
isImplicit
	^ isImplicit! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 1/14/2015 02:34'!
isStartOfRelativeLocationPath
	^ isStartOfRelativeLocationPath! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/14/2015 02:35'!
isStartOfRelativeLocationPath: aBoolean
	isStartOfRelativeLocationPath := aBoolean! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/14/2015 02:34'!
reset
	axisSpecifier := 'child'.
	isImplicit := true.
	isStartOfRelativeLocationPath := false.! !

Object subclass: #XPathCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

!XPathCompiler commentStamp: 'monty 1/18/2015 06:22' prior: 0!
This class compiles XPath expressions by first translating them into Smalltalk using an XPathExpressionParser and handler and then compiling the result with the system compiler.!

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 1/12/2015 05:01'!
compile: aStringOrStream
	^ self compileWithParser:
		(self parserClass
			on: aStringOrStream
			for: self parserHandlerClass new)! !

!XPathCompiler methodsFor: 'private' stamp: 'monty 2/10/2015 01:56'!
compileSource: aString
	"overridden in Gemstone version"
	^ Compiler evaluate: aString! !

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 1/11/2015 10:07'!
compileWithParser: aParser
	^ self compileSource: aParser parse! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 1/8/2015 05:56'!
parserClass
	^ XPathExpressionParser! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 1/11/2015 10:12'!
parserHandlerClass
	^ XPathExpressionParserHandler! !

Object subclass: #XPathContext
	instanceVariableNames: 'variables functions namespaceScope functionStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext commentStamp: 'monty 3/25/2015 01:06' prior: 0!
An XPath context is used to evaluate XPath expressions. Each context has a function library and optionally also variable bindings and namespace mappings.

If no namespace mappings are set in the context, then name tests like 'prefix:name', '*:name', and 'prefix:*' will match against the literal name part(s) of nodes directly (where wildcards matching any). This is different from the spec which needs prefixes in tests to be declared in the context.

Standard behavior (where you must declare any prefix used in a node test) is triggered only if at least one prefix is declared in the context.!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext class methodsFor: 'accessing' stamp: 'monty 1/18/2015 05:53'!
defaultFunctions
	^ defaultFunctions ifNil: [defaultFunctions := XPathFunctionSet default]! !

!XPathContext class methodsFor: 'accessing' stamp: 'monty 3/8/2015 11:46'!
defaultFunctions: aFunctionSet
	"can be used to replace default function set with a custom function set"
	defaultFunctions := aFunctionSet! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:49'!
functions: aFunctionSet
	^ self new functions: aFunctionSet! !

!XPathContext class methodsFor: 'class initialization' stamp: 'monty 3/8/2015 11:45'!
initialize
	"self initialize"

	self defaultFunctions: nil! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
namespaces: anAssociationCollection
	^ self new declareNamespaces: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
variables: anAssociationCollection
	^ self new variables: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection functions: aFunctionSet
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection;
		functions: aFunctionSet! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
addFunction: aFunction
	functions := self functions + aFunction! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 1/19/2015 08:24'!
declareNamespaces: anAssociationCollection
	self namespaceScope mapPrefixesAndURIs: anAssociationCollection! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/21/2015 23:11'!
declarePrefix: aPrefix uri: aURI
	self namespaceScope
		mapPrefix: aPrefix
		to: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:01'!
errorUndeclaredFunction: aFunctionName
	XPathUndeclaredFunctionException
		formatSignal: 'Undeclared function {1}()'
		with: aFunctionName! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/5/2015 07:05'!
errorUndeclaredPrefix: aPrefix
	XPathUndeclaredPrefixException
		formatSignal: 'Prefix "{1}" was not declared in the XPath context'
		with: aPrefix! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:02'!
errorUndeclaredVariable: aVariableName
	XPathUndeclaredVariableException
		formatSignal: 'Undeclared variable reference ${1}'
		with: aVariableName! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/10/2015 19:20'!
function: aFunctionName contextNode: aContextNode
	^ (self functions
		functionNamed: aFunctionName
		ifAbsent: [self errorUndeclaredFunction: aFunctionName])
		context: self
		contextNode: aContextNode! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 08:54'!
functions
	^ functions ifNil: [functions := self class defaultFunctions]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
functions: aFunctionSet
	functions := aFunctionSet! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 01:02'!
hasNamespaces
	^ namespaceScope notNil
		and: [namespaceScope hasNamespaces]! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/10/2015 22:05'!
includesFunction: aFunction
	^ self functions includes: aFunction! !

!XPathContext methodsFor: 'testing' stamp: 'monty 1/17/2015 04:48'!
includesVariable: aVariableName
	^ self variables includesKey: aVariableName! !

!XPathContext methodsFor: 'initialization' stamp: 'monty 1/1/2015 00:54'!
initialize
	super initialize.
	functionStack := OrderedCollection new.! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 20:52'!
isDeclaredPrefix: aPrefix
	^ self namespaceScope includesPrefix: aPrefix! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/21/2015 23:11'!
isDeclaredPrefix: aPrefix uri: aURI
	^ self namespaceScope
		includesPrefix: aPrefix
		mappedTo: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 12/30/2014 03:46'!
namespaceScope
	^ namespaceScope ifNil: [namespaceScope := XMLNamespaceScope new]! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/14/2015 04:57'!
pop
	^ functionStack removeLast! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/22/2015 02:54'!
prefixesOfNamespaceURI: aURI
	^ self namespaceScope prefixesOfNamespaceURI: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/14/2015 04:57'!
push: anObject
	^ functionStack addLast: anObject! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
removeFunction: aFunction
	functions := self functions - aFunction! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/5/2015 07:05'!
resolvePrefix: aPrefix
	^ self namespaceScope
		resolvePrefix: aPrefix
		ifUnresolvable: [self errorUndeclaredPrefix: aPrefix]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:01'!
testForAttributeWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isAttribute
					and: [node hasPrefixedNamespaceURI: namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isAttribute
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:02'!
testForAttributeWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isAttribute
					and: [node localName = aLocalName
						and: [node hasPrefixedNamespaceURI: namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithPrefix: aPrefix.
			^ [:node |
				node isAttribute
					and: [node name = name]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:02'!
testForElementWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isElement
					and: [node hasPrefixedNamespaceURI: namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isElement
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:02'!
testForElementWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isElement
					and: [node localName = aLocalName
						and: [node hasPrefixedNamespaceURI: namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithPrefix: aPrefix.
			^ [:node |
				node isElement
					and: [node name = name]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:01'!
testForPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isPrincipalNode
					and: [node hasPrefixedNamespaceURI: namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isPrincipalNode
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:00'!
testForPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isPrincipalNode
					and: [node localName = aLocalName
						and: [node hasPrefixedNamespaceURI: namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithPrefix: aPrefix.
			^ [:node |
				node isPrincipalNode
					and: [node name = name]]]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 12/30/2014 03:48'!
undeclarePrefix: aPrefix
	self namespaceScope unmapPrefix: aPrefix! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/18/2015 14:00'!
variableAt: aVariableName
	^ self variables
		at: aVariableName
		ifAbsent: [self errorUndeclaredVariable: aVariableName]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsent: aBlock
	^ self variables
		at: aVariableName
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsentPut: aBlock
	^ self variables
		at: aVariableName
		ifAbsentPut: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:48'!
variableAt: aVariableName put: aValue
	^ self variables
		at: aVariableName
		put: aValue! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/17/2015 04:49'!
variables
	^ variables ifNil: [variables := Dictionary new]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 2/13/2015 00:55'!
variables: anAssociationCollection
	variables :=
		anAssociationCollection isDictionary
			ifTrue: [anAssociationCollection]
			ifFalse: [Dictionary withAll: anAssociationCollection]! !

Object subclass: #XPathFunction
	instanceVariableNames: 'context contextNode totalPushedArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

XPathFunction class
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'!

!XPathFunction commentStamp: 'monty 3/13/2015 22:17' prior: 0!
An abstract class for XPath functions. Subclasses need to override the class-side functionPrototype method to return a string containing an XPath function prototype and then implement the instance-side function method to implement the function.

Arguments are passed to functions using a stack and are popped off in LIFO order (last arg popped off first). This is because functions can have optional arguments or even an unbounded number of arguments.

Arguments and return values are automatically converted to the types specified by the prototype.!

XPathFunction class
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'!

XPathFunction subclass: #XPathBooleanFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathBooleanFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath boolean conversion function.!

!XPathBooleanFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:30'!
functionPrototype
	^ 'boolean boolean(object)'! !

!XPathBooleanFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	^ self pop! !

XPathFunction subclass: #XPathCeilingFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCeilingFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath ceiling function.!

!XPathCeilingFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:19'!
functionPrototype
	^ 'number ceiling(number)'! !

!XPathCeilingFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	^ self pop ceiling! !

XPathFunction subclass: #XPathConcatFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathConcatFunction commentStamp: 'monty 3/13/2015 21:27' prior: 0!
XPath string concatenation function. Concatenates two or more strings.!

!XPathConcatFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:32'!
functionPrototype
	^ 'string concat(string, string, string*)'! !

!XPathConcatFunction methodsFor: 'invoking' stamp: 'monty 1/19/2015 06:08'!
function
	| concatenation |

	concatenation := self pop.
	[self totalPushedArguments > 0]
		whileTrue: [concatenation := self pop, concatenation].
	^ concatenation.! !

XPathFunction subclass: #XPathContainsFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathContainsFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath contains substring function.!

!XPathContainsFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:37'!
functionPrototype
	^ 'boolean contains(string, string)'! !

!XPathContainsFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:51'!
function
	| substring |

	substring := self pop.
	"use findString:startingAt: for portability"
	^ (self pop
		findString: substring
		startingAt: 1) > 0! !

XPathFunction subclass: #XPathCountFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCountFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath NodeSet count (size) function.!

!XPathCountFunction class methodsFor: 'accessing' stamp: 'monty 12/25/2014 00:08'!
functionPrototype
	^ 'number count(node-set)'! !

!XPathCountFunction methodsFor: 'invoking' stamp: 'monty 12/25/2014 00:09'!
function
	^ self pop size! !

XPathFunction subclass: #XPathEndsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathEndsWithFunction commentStamp: 'monty 2/12/2015 20:25' prior: 0!
Non-standard, but added for completeness with starts-with().!

!XPathEndsWithFunction class methodsFor: 'accessing' stamp: 'monty 2/12/2015 20:24'!
functionPrototype
	^ 'boolean ends-with(string, string)'! !

!XPathEndsWithFunction methodsFor: 'invoking' stamp: 'monty 2/12/2015 20:25'!
function
	| substring |

	substring := self pop.
	^ self pop endsWith: substring.! !

XPathFunction subclass: #XPathFalseFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFalseFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath false function.!

!XPathFalseFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:27'!
functionPrototype
	^ 'boolean false()'! !

!XPathFalseFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:51'!
function
	^ false! !

XPathFunction subclass: #XPathFloorFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFloorFunction commentStamp: 'monty 12/22/2014 21:18' prior: 0!
XPath floor function.!

!XPathFloorFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:17'!
functionPrototype
	^ 'number floor(number)'! !

!XPathFloorFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:55'!
function
	^ self pop floor! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 12/29/2014 21:32'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetWithFunction: self! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 12/29/2014 21:33'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetSubtractedFromFunction: self! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:00'!
argumentTypes
	^ argumentTypes
		ifNil: [
			self parseFunctionPrototype.
			argumentTypes]! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/15/2015 09:51'!
asFunctionSet
	^ XPathFunctionSet with: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/15/2015 09:54'!
asFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 12/29/2014 21:34'!
asFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/17/2015 12:15'!
asFunctionSetWithFunction: aFunction
	^ self asFunctionSet
		add: aFunction;
		yourself! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/17/2015 12:16'!
asFunctionSetWithFunctions: aFunctionSet
	^ self asFunctionSet
		addAll: aFunctionSet;
		yourself! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 12/22/2014 18:03'!
classForTypeName: aTypeName
	aTypeName = 'object'
		ifTrue: [^ Object].
	aTypeName = 'boolean'
		ifTrue: [^ Boolean].
	aTypeName = 'string'
		ifTrue: [^ String].
	aTypeName = 'number'
		ifTrue: [^ Number].
	aTypeName = 'node-set'
		ifTrue: [^ XPathNodeSet].
	^ nil.! !

!XPathFunction class methodsFor: 'instance creation' stamp: 'monty 12/29/2014 06:24'!
context: aContext contextNode: aContextNode
	^ self new
		setContext: aContext
		contextNode: aContextNode! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:16'!
functionName
	^ functionName
		ifNil: [
			self parseFunctionPrototype.
			functionName]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:36'!
functionPrototype
	"should return a protype string. see subclasses for examples."
	self subclassResponsibility! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:23'!
maxArguments
	^ maxArguments
		ifNil: [
			self parseFunctionPrototype.
			maxArguments]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:23'!
minArguments
	^ minArguments
		ifNil: [
			self parseFunctionPrototype.
			minArguments]! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 3/10/2015 19:26'!
parseFunctionPrototype
	"self allSubclassesDo: [:each | each parseFunctionPrototype]"

	(XPathFunctionPrototypeParser
		on: self functionPrototype
		for: (XPathFunctionPrototypeParserHandler function: self))
		parse! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:30'!
returnType
	^ returnType
		ifNil: [
			self parseFunctionPrototype.
			returnType]! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 12/23/2014 14:31'!
setReturnType: aReturnType functionName: aName minArguments: aMinimum maxArguments: aMaximum argumentTypes: anArgumentTypeCollection
	returnType := aReturnType.
	functionName := aName.
	minArguments := aMinimum.
	maxArguments := aMaximum.
	argumentTypes := anArgumentTypeCollection asArray.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:42'!
argumentTypeAt: anInteger
	^ self argumentTypes at: (anInteger min: self argumentTypes size)! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
argumentTypes
	^ self class argumentTypes! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/24/2014 23:45'!
context
	^ context! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/14/2015 04:58'!
contextNode
	^ contextNode! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/18/2015 13:59'!
errorTooFewArguments
	XPathArgumentNumberException
		formatSignal: '{1}() requires at least {2} arguments'
		with: self functionName
		with: self minArguments! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/18/2015 13:59'!
errorTooManyArguments
	XPathArgumentNumberException
		formatSignal: '{1}() accepts at most {2} arguments'
		with: self functionName
		with: self maxArguments! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	self subclassResponsibility! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
functionName
	^ self class functionName! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:50'!
functionPrototype
	^ self class functionPrototype! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 12/27/2014 04:08'!
invoke
	totalPushedArguments < self minArguments
		ifTrue: [self errorTooFewArguments].

	^ self returnType xPathNewFrom: self function.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
maxArguments
	^ self class maxArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
minArguments
	^ self class minArguments! !

!XPathFunction methodsFor: 'stack' stamp: 'monty 2/9/2015 22:08'!
pop
	totalPushedArguments := totalPushedArguments - 1.
	^ context pop.! !

!XPathFunction methodsFor: 'printing' stamp: 'monty 1/19/2015 12:57'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: '(''';
		nextPutAll: self functionPrototype;
		nextPutAll: ''')'.! !

!XPathFunction methodsFor: 'stack' stamp: 'monty 1/14/2015 04:58'!
push: anArgument
	self maxArguments
		ifNotNil: [:maxArguments |
			totalPushedArguments >= maxArguments
				ifTrue: [self errorTooManyArguments]].

	totalPushedArguments := totalPushedArguments + 1.
	context push:
		((self argumentTypeAt: totalPushedArguments)
			xPathNewFrom: anArgument).! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:38'!
returnType
	^ self class returnType! !

!XPathFunction methodsFor: 'initialization' stamp: 'monty 12/29/2014 06:25'!
setContext: aContext contextNode: aContextNode
	context := aContext.
	contextNode := aContextNode.
	totalPushedArguments := 0.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/26/2014 03:32'!
totalPushedArguments
	^ totalPushedArguments! !

XPathFunction subclass: #XPathIDFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathIDFunction commentStamp: 'monty 3/9/2015 21:50' prior: 0!
XPath id() function to select elements from the document of the context node by ID.!

!XPathIDFunction class methodsFor: 'accessing' stamp: 'monty 3/8/2015 11:05'!
functionPrototype
	^ 'node-set id(object)'! !

!XPathIDFunction methodsFor: 'private' stamp: 'monty 3/25/2015 00:59'!
addElementsWithIDs: anIDSet from: aDocument to: aNodeSet
	| doctypeDefinition elementsAndIDAttributes |

	((doctypeDefinition := aDocument doctypeDefinition) notNil
		and: [doctypeDefinition hasElementIDValidator])
		ifFalse: [^ self].
	elementsAndIDAttributes :=
		doctypeDefinition elementIDValidator elementsAndIDAttributes.

	aDocument allElementsDo: [:each |
		each hasAttributes
			ifTrue: [
				elementsAndIDAttributes
					at: each name
					ifPresent: [:idAttribute |
						((each includesAttribute: idAttribute)
							and: [anIDSet includes: (each attributeAt: idAttribute)])
							ifTrue: [aNodeSet add: each]]]].! !

!XPathIDFunction methodsFor: 'invoking' stamp: 'monty 3/25/2015 19:40'!
function
	| object ids document nodeSet |

	object := self pop.
	ids := Set new.
	(object isKindOf: XPathNodeSet)
		ifTrue: [
			object do: [:each |
				self
					splitSpaceSeparatedIDs: each stringValue
					into: ids]]
		ifFalse: [
			self
				splitSpaceSeparatedIDs: object asXPathString
				into: ids].

	nodeSet := XPathNodeSet new.
	(ids notEmpty
		and: [self contextNode notNil
			and: [(document := self contextNode document) notNil]])
		ifTrue: [
			self
				addElementsWithIDs: ids
				from: document
				to: nodeSet].
	^ nodeSet.! !

!XPathIDFunction methodsFor: 'private' stamp: 'monty 3/25/2015 00:58'!
splitSpaceSeparatedIDs: anIDString into: anIDSet
	| startIndex|

	1 to: anIDString size do: [:i | | nextChar |
		(nextChar := anIDString at: i) isSeparator
			ifTrue: [
				startIndex
					ifNotNil: [
						anIDSet add: (anIDString copyFrom: startIndex to: i - 1).
						startIndex := nil]]
			ifFalse: [
				startIndex
					ifNil: [startIndex := i]]].
	startIndex
		ifNotNil: [
			anIDSet add:
				(anIDString copyFrom: startIndex to: anIDString size)].! !

XPathFunction subclass: #XPathLangFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLangFunction commentStamp: 'monty 3/25/2015 04:12' prior: 0!
XPath lang() function to test if the context node is in the scope of an xml:lang attribute value matching the argument.!

!XPathLangFunction class methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:18'!
functionPrototype
	^ 'boolean lang(string)'! !

!XPathLangFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:55'!
function
	| language |

	language := self pop.
	^ self contextNode isInLanguage: language.! !

XPathFunction subclass: #XPathLocalNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLocalNameFunction commentStamp: 'monty 12/27/2014 00:36' prior: 0!
XPath local name function.!

!XPathLocalNameFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:19'!
functionPrototype
	^ 'string local-name(node-set?)'! !

!XPathLocalNameFunction methodsFor: 'invoking' stamp: 'monty 1/18/2015 16:45'!
function
	| node |

	self totalPushedArguments > 0
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [^ node localName]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNameFunction commentStamp: 'monty 3/5/2015 15:46' prior: 0!
XPath name function. Returns expanded name or local name of a node or empty string if node has no name. Operates on argument node or the context node if called with no arguments.!

!XPathNameFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:22'!
functionPrototype
	^ 'string name(node-set?)'! !

!XPathNameFunction methodsFor: 'invoking' stamp: 'monty 3/25/2015 01:03'!
function
	| node |

	self totalPushedArguments > 0
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [| namespaceURI |
			(self context hasNamespaces
				and: [(namespaceURI := node namespaceURI) notEmpty
					and: [node hasPrefix]])
				ifTrue: [
					((self context prefixesOfNamespaceURI: namespaceURI)
						ifEmpty: [^ node localName]
						ifNotEmpty: [:prefixes |
							^ node localName qualifyWithPrefix: prefixes anyOne])]
				ifFalse: [^ node name]]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathNamespaceURIFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNamespaceURIFunction commentStamp: 'monty 12/27/2014 00:27' prior: 0!
XPath namespace URI function.!

!XPathNamespaceURIFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:20'!
functionPrototype
	^ 'string namespace-uri(node-set?)'! !

!XPathNamespaceURIFunction methodsFor: 'invoking' stamp: 'monty 1/20/2015 12:18'!
function
	| node |

	self totalPushedArguments > 0
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [^ node namespaceURI]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNormalizeSpaceFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNormalizeSpaceFunction commentStamp: 'monty 3/13/2015 22:30' prior: 0!
XPath whitespace normalization function to remove leading and trailing whitespace and turn multiple whitespace character sequences into single spaces.!

!XPathNormalizeSpaceFunction class methodsFor: 'accessing' stamp: 'monty 12/25/2014 04:35'!
functionPrototype
	^ 'string normalize-space(string?)'! !

!XPathNormalizeSpaceFunction methodsFor: 'invoking' stamp: 'monty 12/26/2014 03:32'!
function
	| string writeStream isInWhitespace |

	self totalPushedArguments > 0
		ifTrue: [string := self pop]
		ifFalse: [string := self contextNode].

	writeStream := (String new: string size) writeStream.
	isInWhitespace := false.
	string do: [:each |
		each isSeparator
			ifTrue: [
				isInWhitespace
					ifFalse: [isInWhitespace := true]]
			ifFalse: [
				isInWhitespace
					ifTrue: [
						writeStream xmlParserAtBeginning
							ifFalse: [writeStream nextPut: $ ].
						isInWhitespace := false].
				writeStream nextPut: each]].
	^ writeStream contents.! !

XPathFunction subclass: #XPathNotFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNotFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath negation function.!

!XPathNotFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:10'!
functionPrototype
	^ 'boolean not(boolean)'! !

!XPathNotFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:57'!
function
	^ self pop not! !

XPathFunction subclass: #XPathNumberFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNumberFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number conversion function.!

!XPathNumberFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:11'!
functionPrototype
	^ 'number number(object?)'! !

!XPathNumberFunction methodsFor: 'invoking' stamp: 'monty 12/26/2014 03:32'!
function
	self totalPushedArguments > 0
		ifTrue: [^ self pop]
		ifFalse: [^ XPathNodeSet with: self contextNode]! !

XPathFunction subclass: #XPathRoundFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathRoundFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number rounding function.!

!XPathRoundFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:20'!
functionPrototype
	^ 'number round(number)'! !

!XPathRoundFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:58'!
function
	^ self pop rounded! !

XPathFunction subclass: #XPathStartsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStartsWithFunction commentStamp: 'monty 2/10/2015 02:59' prior: 0!
XPath string prefix testing function.!

!XPathStartsWithFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:25'!
functionPrototype
	^ 'boolean starts-with(string, string)'! !

!XPathStartsWithFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	| substring |

	substring := self pop.
	^ self pop beginsWith: substring.! !

XPathFunction subclass: #XPathStringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringFunction commentStamp: 'monty 12/22/2014 20:01' prior: 0!
XPath string conversion function.!

!XPathStringFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:30'!
functionPrototype
	^ 'string string(object?)'! !

!XPathStringFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	^ self pop! !

XPathFunction subclass: #XPathStringLengthFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringLengthFunction commentStamp: 'monty 12/22/2014 21:24' prior: 0!
XPath string length function.
!

!XPathStringLengthFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:22'!
functionPrototype
	^ 'number string-length(string?)'! !

!XPathStringLengthFunction methodsFor: 'invoking' stamp: 'monty 3/25/2015 19:42'!
function
	self totalPushedArguments > 0
		ifTrue: [^ self pop size]
		ifFalse: [^ self contextNode stringValue size]! !

XPathFunction subclass: #XPathSubstringAfterFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringAfterFunction commentStamp: 'monty 3/13/2015 22:26' prior: 0!
XPath function to return substring after another substring.!

!XPathSubstringAfterFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:48'!
functionPrototype
	^ 'string substring-after(string, string)'! !

!XPathSubstringAfterFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	| substring string indexOfSubstring |

	substring := self pop.
	string := self pop.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: indexOfSubstring + substring size
				to: string size]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringBeforeFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringBeforeFunction commentStamp: 'monty 3/13/2015 22:26' prior: 0!
XPath function to return substring before another substring.!

!XPathSubstringBeforeFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:40'!
functionPrototype
	^ 'string substring-before(string, string)'! !

!XPathSubstringBeforeFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:54'!
function
	| substring string indexOfSubstring |

	substring := self pop.
	string := self pop.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: 1
				to:indexOfSubstring - 1]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringFunction commentStamp: 'monty 2/10/2015 06:21' prior: 0!
XPath substring function. First argument is source string, second is one-based position, and third is substring length.!

!XPathSubstringFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:53'!
functionPrototype
	^ 'string substring(string, number, number?)'! !

!XPathSubstringFunction methodsFor: 'invoking' stamp: 'monty 2/10/2015 06:36'!
function
	| string start length |

	self totalPushedArguments > 2
		ifTrue: [
			length := self pop rounded.
			start := self pop rounded.
			string := self pop]
		ifFalse: [
			start := self pop rounded.
			string := self pop.
			length := string size - start + 1].

	(length > 0 and: [start <= string size])
		ifTrue: [
			^ string
				copyFrom: (start max: 1)
				to: ((start max: 1) + length - 1 min: string size)]
		ifFalse: [^ '']	.! !

XPathFunction subclass: #XPathSumFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSumFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath sum function.!

!XPathSumFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:06'!
functionPrototype
	^ 'number sum(node-set)'! !

!XPathSumFunction methodsFor: 'invoking' stamp: 'monty 3/25/2015 19:42'!
function
	^ self pop
		inject: 0
		into: [:i :each | i + each stringValue asXPathNumber]! !

XPathFunction subclass: #XPathTranslateFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTranslateFunction commentStamp: 'monty 3/13/2015 22:24' prior: 0!
XPath function to replace or delete all occurances of certain characters in a string.!

!XPathTranslateFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:57'!
functionPrototype
	^ 'string translate(string, string, string)'! !

!XPathTranslateFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:53'!
function
	| replacementTable translatedString replacementString searchString sourceString |

	replacementTable := IdentityDictionary new.
	replacementString := self pop.
	searchString := self pop.
	1 to: searchString size do: [:i |
		replacementTable
			at: (searchString at: i)
			ifAbsentPut: (replacementString at: i ifAbsent: [nil])].

	sourceString := self pop.
	translatedString := (String new: sourceString size) writeStream.
	sourceString do: [:each |	
		(replacementTable at: each ifAbsent: [each])
			ifNotNil: [:nextChar |
				translatedString nextPut: nextChar]].
	^ translatedString contents.! !

XPathFunction subclass: #XPathTrueFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTrueFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath true function.!

!XPathTrueFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:24'!
functionPrototype
	^ 'boolean true()'! !

!XPathTrueFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:53'!
function
	^ true! !

Object subclass: #XPathNodeTestParserContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

XPathNodeTestParserContext class
	instanceVariableNames: 'instance'!

!XPathNodeTestParserContext commentStamp: 'monty 3/1/2015 08:10' prior: 0!
This is an abstract base class for node tests parser contexts.!

XPathNodeTestParserContext class
	instanceVariableNames: 'instance'!

XPathNodeTestParserContext subclass: #XPathAttributeTypeNodeTestParserContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathAttributeTypeNodeTestParserContext commentStamp: 'monty 2/27/2015 06:11' prior: 0!
A context for parsing the arguments of an attribute type test.!

!XPathAttributeTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleEmptyTestWith: aHandler
	aHandler handleTestForAttributeWithAnyName! !

!XPathAttributeTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForAttributeWithAnyName! !

!XPathAttributeTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:47'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForAttributeWithLocalName: aLocalName! !

!XPathAttributeTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 13:26'!
handleTestForName: aName with: aHandler
	aHandler handleTestForAttributeWithName: aName! !

!XPathAttributeTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForAttributeWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathAttributeTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:43'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForAttributeWithPrefix: aPrefix
		localName: aLocalName! !

!XPathAttributeTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:06'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForAttributeWithPrefix: aPrefix! !

!XPathAttributeTypeNodeTestParserContext methodsFor: 'testing' stamp: 'monty 3/1/2015 08:15'!
isTypeTestParserContext
	^ true! !

XPathNodeTestParserContext subclass: #XPathElementTypeNodeTestParserContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathElementTypeNodeTestParserContext commentStamp: 'monty 2/27/2015 06:11' prior: 0!
A context for parsing the arguments of an element type test.!

!XPathElementTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleEmptyTestWith: aHandler
	aHandler handleTestForElementWithAnyName! !

!XPathElementTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForElementWithAnyName! !

!XPathElementTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:47'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForElementWithLocalName: aLocalName! !

!XPathElementTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 13:27'!
handleTestForName: aName with: aHandler
	aHandler handleTestForElementWithName: aName! !

!XPathElementTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForElementWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathElementTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:43'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForElementWithPrefix: aPrefix
		localName: aLocalName! !

!XPathElementTypeNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:04'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForElementWithPrefix: aPrefix! !

!XPathElementTypeNodeTestParserContext methodsFor: 'testing' stamp: 'monty 3/1/2015 08:15'!
isTypeTestParserContext
	^ true! !

XPathNodeTestParserContext subclass: #XPathInitialNodeTestParserContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathInitialNodeTestParserContext commentStamp: 'monty 3/5/2015 19:23' prior: 0!
An initial context for parsing node test.!

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:16'!
handleEmptyTestWith: aHandler
	aHandler handleEmptyTest! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:37'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForAnyName! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeTypeWith: aHandler
	aHandler handleTestForAnyNodeType! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:16'!
handleTestForCommentTypeWith: aHandler
	aHandler handleTestForCommentType! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:48'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForLocalName: aLocalName! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:26'!
handleTestForName: aName with: aHandler
	aHandler handleTestForName: aName! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:16'!
handleTestForNamespaceTypeWith: aHandler
	aHandler handleTestForNamespaceType! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForNamespaceURI: aURI
		localName: aLocalName! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:48'!
handleTestForPITypeWith: aHandler
	aHandler handleTestForPIType! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 15:24'!
handleTestForPIWithName: aName with: aHandler
	aHandler handleTestForPIWithName: aName! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:44'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForPrefix: aPrefix
		localName: aLocalName! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForPrefix: aPrefix! !

!XPathInitialNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextTypeWith: aHandler
	aHandler handleTestForTextType! !

!XPathInitialNodeTestParserContext methodsFor: 'testing' stamp: 'monty 3/1/2015 11:39'!
isTypeTestParserContext
	^ false! !

!XPathNodeTestParserContext class methodsFor: 'instance creation' stamp: 'monty 2/22/2015 00:01'!
new
	"these classes are shared immutable for efficiency"
	^ instance ifNil: [instance := self basicNew initialize]! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:16'!
handleEmptyTestWith: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:46'!
handleTestForLocalName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:18'!
handleTestForName: aName with: aHandler
	self subclassResponsibility
! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:42'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForPrefix: aPrefix with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'testing' stamp: 'monty 3/1/2015 11:39'!
isTypeTestParserContext
	self subclassResponsibility! !

Object subclass: #XPathParser
	instanceVariableNames: 'handler inputStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParser commentStamp: 'monty 1/8/2015 09:14' prior: 0!
This is a base class for XPath parsers.!

XPathParser subclass: #XPathExpressionParser
	instanceVariableNames: 'currentAxis nodeTestParser'
	classVariableNames: 'AbbreviatedAxisSpecifierCharacters'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParser commentStamp: 'monty 2/10/2015 02:58' prior: 0!
This class parses XPath expressions. It understands all of XPath 1.0 syntax and supports some extensions like abbreviated syntax for other axis specifiers.!

!XPathExpressionParser class methodsFor: 'class initialization' stamp: 'monty 1/10/2015 09:03'!
initialize
	"self initialzie"

	self initializeAbbreviatedAxisSpecifierCharacters! !

!XPathExpressionParser class methodsFor: 'class initialization' stamp: 'monty 1/22/2015 15:52'!
initializeAbbreviatedAxisSpecifierCharacters
	(AbbreviatedAxisSpecifierCharacters := BitmapCharacterSet new)
		addAll: '%@~<>'! !

!XPathExpressionParser methodsFor: 'testing' stamp: 'monty 3/10/2015 19:38'!
atDigit
	| nextChar |

	^ (nextChar := inputStream peek) notNil
		and: [nextChar isDigit]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/21/2015 18:29'!
errorExpectedNodeTest
	self errorExpected: 'node test after axis'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/14/2015 04:35'!
errorExpectedStep
	self errorExpected: 'location path step'! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/26/2015 20:32'!
nextAdditionalSteps
	self peekForAdditionalSteps
		ifFalse: [self errorExpectedStep]! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 10:48'!
nextAdditiveExpression
	handler handleStartAdditiveExpression.
	self nextMultiplicativeExpression.
	[self peekForAdditiveOperator]
		whileTrue: [self nextMultiplicativeExpression].
	handler handleEndAdditiveExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/11/2015 00:11'!
nextAndExpression
	| totalShortCircuited |

	handler handleStartAndExpression.
	self nextEqualityExpression.
	totalShortCircuited := 0.
	[self peekForAndOperator]
		whileTrue: [
			handler handleStartShortCircuitAnd.
			totalShortCircuited := totalShortCircuited + 1.
			self nextEqualityExpression].
	handler
		handleEndShortCircuited: totalShortCircuited;
		handleEndAndExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:19'!
nextArgument
	handler handleStartFunctionArgument.
	self nextOrExpression.
	handler handleEndFunctionArgument.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/18/2015 15:21'!
nextDigitsOnWriteStream
	"first digit"
	writeStream nextPut: inputStream next.
	[self atDigit]
		whileTrue: [writeStream nextPut: inputStream next].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 11:10'!
nextEqualityExpression
	handler handleStartEqualityExpression.
	self nextRelationalExpression.
	[self peekForEqualityOperator]
		whileTrue: [self nextRelationalExpression].
	handler handleEndEqualityExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 04:08'!
nextFilterExpression
	self
		nextPrimaryExpression;
		peekForPredicates! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:17'!
nextFunctionCall
	| name |

	name := self nextName.
	name = 'position'
		ifTrue: [
			handler handlePositionFunctionCall.
			^ self nextEmptyArgumentList].
	name = 'last'
		ifTrue: [
			handler handleLastFunctionCall.
			^ self nextEmptyArgumentList].

	handler handleStartFunctionCall: name.
	self nextArgumentList.
	handler handleEndFunctionCall.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 07:43'!
nextMultiplicativeExpression
	handler handleStartMultiplicativeExpression.
	self nextUnaryExpression.
	[self peekForMultiplicativeOperator]
		whileTrue: [self nextUnaryExpression].
	handler handleEndMultiplicativeExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/11/2015 00:11'!
nextOrExpression
	| totalShortCircuited |

	handler handleStartOrExpression.
	self nextAndExpression.
	totalShortCircuited := 0.
	[self peekForOrOperator]
		whileTrue: [
			handler handleStartShortCircuitOr.
			totalShortCircuited := totalShortCircuited + 1.
			self nextAndExpression].
	handler
		handleEndShortCircuited: totalShortCircuited;
		handleEndOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/22/2015 22:30'!
nextPathExpression
	handler handleStartPathExpression.
	self peekForLocationPathExpression
		ifFalse: [
			self nextFilterExpression.
			self peekForLocationPathSeparator
				ifTrue: [self nextAdditionalSteps]].
	handler handleEndPathExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/20/2015 19:39'!
nextPrimaryExpression
	inputStream skipSeparators.
	(self peekForVariableReference
		or: [self peekForParenthesizedExpression
			or: [self peekForStringLiteral
				or: [self peekForNumber]]])
		ifFalse: [self nextFunctionCall].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:46'!
nextRelationalExpression
	handler handleStartRelationalExpression.
	self nextAdditiveExpression.
	[self peekForRelationalOperator]
		whileTrue: [self nextAdditiveExpression].
	handler handleEndRelationalExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 22:10'!
nextUnaryExpression
	| totalNegations |

	handler handleStartUnaryExpression.
	totalNegations := 0.
	[self peekForNegationOperator]
		whileTrue: [totalNegations := totalNegations + 1].
	totalNegations odd
		ifTrue: [handler handleNegation].
	self nextUnionExpression.
	handler handleEndUnaryExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:07'!
nextUnionExpression
	handler handleStartUnionExpression.
	self nextPathExpression.
	[self peekForUnion]
		whileTrue: [self nextPathExpression].
	handler handleEndUnionExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:24'!
parseInput
	currentAxis := XPathAxis new.
	nodeTestParser :=
		XPathNodeTestParser
			on: inputStream
			for:
				(XPathExpressionNodeTestParserHandler
					currentAxis: currentAxis
					expressionParserHandler: handler).
	self nextOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 22:11'!
peekFailedAt: aPosition
	inputStream position: aPosition.
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/15/2015 04:00'!
peekForAbbreviatedAxis
	| nextChar |

	((nextChar := inputStream peek) notNil
		and: [AbbreviatedAxisSpecifierCharacters includes: nextChar])
		ifFalse: [^ false].
	writeStream
		reset;
		nextPut: inputStream next.
	[(nextChar := inputStream peek) notNil
		and: [AbbreviatedAxisSpecifierCharacters includes: nextChar]]
		whileTrue: [writeStream nextPut: inputStream next].
	currentAxis axisSpecifier: writeStream contents.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/26/2015 20:56'!
peekForAbbreviatedDescendantStep
	(inputStream peekFor: $/)
		ifFalse: [^ false].

	"// followed by a node test is the same as
	descendant:: followed by the node test"
	currentAxis axisSpecifier: 'descendant'.
	nodeTestParser parse
		ifTrue: [self peekForPredicates]
		ifFalse: [
			"// followed by an abbreviated step or step with an
			explicit axis is the same as descendant-or-self::node()/
			followed by the step"
			currentAxis
				axisSpecifier: 'descendant-or-self';
				handleWith: handler.
			handler handleTestForAnyNodeType.
			self peekForStep
				ifFalse: [self errorExpectedStep]].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 08:44'!
peekForAbbreviatedStep
	(inputStream peekFor: $.)
		ifFalse: [^ false].
	self atDigit
		ifTrue: [
			inputStream skipBack.
			^ false].
	(inputStream peekFor: $.)
		ifTrue: [currentAxis axisSpecifier: 'parent']
		ifFalse: [
			currentAxis isStartOfRelativeLocationPath
				ifFalse: [
					"can be omitted"
					currentAxis reset.
					^ true].
			currentAxis axisSpecifier: 'self'].
	currentAxis handleWith: handler.
	handler handleTestForAnyNodeType.

	"abbreviated steps cannot have filters"
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/26/2015 20:38'!
peekForAbsoluteLocationPath
	self peekForLocationPathSeparator
		ifFalse: [^ false].
	handler handleStartAbsoluteLocationPath.
	self peekForAdditionalSteps
		ifFalse: [
			currentAxis
				axisSpecifier: 'self';
				handleWith: handler.
			handler handleTestForAnyNodeType].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/26/2015 20:31'!
peekForAdditionalSteps
	currentAxis reset.
	(self peekForAbbreviatedDescendantStep
		or: [self peekForStep])
		ifFalse: [^ false].
	[self peekForLocationPathSeparator]
		whileTrue: [
			(self peekForAbbreviatedDescendantStep
				or: [self peekForStep])
				ifFalse: [self errorExpectedStep]].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/12/2015 05:10'!
peekForAdditiveOperator
	inputStream skipSeparators.
	(inputStream peekFor: $+)
		ifTrue: [
			handler handleAddition.
			^ true].
	(inputStream peekFor: $-)
		ifTrue: [
			handler handleSubtraction.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:35'!
peekForAndOperator
	inputStream skipSeparators.
	^ inputStream peekForAll: 'and'.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/2/2015 04:38'!
peekForAttributePredicate
	| startPosition namePosition ncName isNotEquals stringLiteral |

	startPosition := inputStream position.
	(inputStream peekFor: $@)
		ifFalse: [^ false].

	inputStream skipSeparators.
	namePosition := inputStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ self peekFailedAt: startPosition].

	inputStream skipSeparators.
	isNotEquals := inputStream peekFor: $!!.
	(inputStream peekFor: $=)
		ifTrue: [
			inputStream skipSeparators.
			((stringLiteral := self nextStringLiteralOptional: true) notNil
				and: [self peekForEndPredicate])
				ifTrue: [
					isNotEquals
						ifTrue: [
							handler
								handlePredicateAttribute: ncName
								notEqualsStringLiteral: stringLiteral]
						ifFalse: [
							handler
								handlePredicateAttribute: ncName
								equalsStringLiteral: stringLiteral].
					^ true]].
	inputStream
		pushBackNCName: ncName
		position: namePosition.
	^ self peekFailedAt: startPosition.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/26/2015 14:58'!
peekForAxis
	| startPosition ncName |

	self peekForAbbreviatedAxis
		ifTrue: [^ true].
	startPosition := inputStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ false].
	inputStream skipSeparators.
	((inputStream peekFor: $:)
		and: [inputStream peekFor: $:])
		ifFalse: [
			inputStream
				pushBackNCName: ncName
				position: startPosition.
			^ false].
	currentAxis axisSpecifier: ncName.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/20/2015 11:12'!
peekForEndPredicate
	inputStream skipSeparators.
	^ inputStream peekFor: $].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/13/2015 11:45'!
peekForEqualityOperator
	inputStream skipSeparators.
	(inputStream peekForAll: '!!=')
		ifTrue: [
			handler handleNotEquals.
			^ true].
	(inputStream peekFor: $=)
		ifTrue: [
			handler handleEquals.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:33'!
peekForIntegerPredicate
	| startPosition |

	self atDigit
		ifFalse: [^ false].
	
	startPosition := inputStream position.
	writeStream reset.
	self nextDigitsOnWriteStream.
	self peekForEndPredicate
		ifTrue: [
			handler handleIntegerPredicate: writeStream contents.
			^ true]
		ifFalse: [^ self peekFailedAt: startPosition].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/22/2015 22:21'!
peekForLocationPathExpression
	^ self peekForAbsoluteLocationPath
		or: [self peekForRelativeLocationPath]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/14/2015 02:43'!
peekForLocationPathSeparator
	inputStream skipSeparators.
	^ inputStream peekFor: $/.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:43'!
peekForMultiplicativeOperator
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].
	(inputStream peekFor: $*)
		ifTrue: [
			handler handleMultiplication.
			^ true].
	(inputStream peekForAll: 'div')
		ifTrue: [
			handler handleDivision.
			^ true].
	(inputStream peekForAll: 'mod')
		ifTrue: [
			handler handleModulus.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:45'!
peekForNegationOperator
	inputStream skipSeparators.
	^ inputStream peekFor: $-.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/20/2015 11:02'!
peekForNumber
	| startPosition |

	startPosition := inputStream position.
	writeStream reset.
	self atDigit
		ifTrue: [
			self nextDigitsOnWriteStream.
			(inputStream peekFor: $.)
				ifTrue: [
					"float literals cannot have trailing '.'"
					self atDigit
						ifTrue: [
							writeStream nextPut: $..
							self nextDigitsOnWriteStream]].
			handler handleNumberLiteral: writeStream contents.
			^ true].
	(inputStream peekFor: $.)
		ifTrue: [
			self atDigit
				ifTrue: [
					"float literals can't have leading '.'"
					writeStream nextPutAll: '0.'.
					self nextDigitsOnWriteStream.
					handler handleNumberLiteral: writeStream contents.
					^ true]].
	^ self peekFailedAt: startPosition.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:35'!
peekForOrOperator
	inputStream skipSeparators.
	^ inputStream peekForAll: 'or'.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:41'!
peekForParenthesizedExpression
	(inputStream peekFor: $()
		ifFalse: [^ false].

	self nextOrExpression.
	inputStream skipSeparators.
	self expectNext: $).
	^ true.
! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:34'!
peekForPredicate
	inputStream skipSeparators.
	(inputStream peekFor: $[)
			ifFalse: [^ false].

	inputStream skipSeparators.
	(self peekForIntegerPredicate
		or: [self peekForAttributePredicate])
		ifTrue: [^ true].

	handler handleStartPredicate.
	self nextOrExpression.
	inputStream skipSeparators.
	self expectNext: $].
	handler handleEndPredicate.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/1/2015 16:54'!
peekForPredicates
	[self peekForPredicate] whileTrue! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/13/2015 11:48'!
peekForRelationalOperator
	inputStream skipSeparators.
	(inputStream peekFor: $<)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleLessThanOrEqualTo]
				ifFalse: [handler handleLessThan].
			^ true].
	(inputStream peekFor: $>)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleGreaterThanOrEqualTo]
				ifFalse: [handler handleGreaterThan].
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/22/2015 22:30'!
peekForRelativeLocationPath
	currentAxis
		reset;
		isStartOfRelativeLocationPath: true.
	self peekForStep
		ifFalse: [^ false].
	self peekForLocationPathSeparator
		ifTrue: [self nextAdditionalSteps].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/21/2015 18:30'!
peekForStep
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].
	self peekForAbbreviatedStep
		ifTrue: [^ true].
	self peekForAxis.
	nodeTestParser parse
		ifFalse: [
			currentAxis isImplicit
				ifFalse: [self errorExpectedNodeTest].
			currentAxis reset.
			^ false].
	self peekForPredicates.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/21/2015 07:12'!
peekForStringLiteral
	(self nextStringLiteralOptional: true)
		ifNil: [^ false]
		ifNotNil: [:string |
			handler handleStringLiteral: string.
			^ true]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForUnion
	inputStream skipSeparators.
	(inputStream peekFor: $|)
		ifTrue: [
			handler handleUnion.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForVariableReference
	(inputStream peekFor: $$)
		ifTrue: [
			handler handleVariableReference: self nextName.
			^ true]
		ifFalse: [^ false]! !

XPathParser subclass: #XPathFunctionPrototypeParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFunctionPrototypeParser commentStamp: 'monty 3/15/2015 22:37' prior: 0!
This class parses XPath function prototypes to extract the name, return type, and the number and type of the arguments.!

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorArgumentAfterUnboundedArgument
	XPathSyntaxException signal: 'Argument after unbounded "*" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorNonOptionalArgumentAfterOptional
	XPathSyntaxException signal: 'Non-optional argument afer optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:23'!
errorUnboundedArgumentAfterOptional
	XPathSyntaxException signal: 'Unbounded "*" argument after optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:22'!
nextArgument
	handler hasUnboundedArgument
		ifTrue: [self errorArgumentAfterUnboundedArgument].

	inputStream skipSeparators.
	self nextModifierForArgument: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:38'!
nextFunctionName
	inputStream skipSeparators.
	handler handleFunctionName: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:33'!
nextModifierForArgument: anArgument
	inputStream skipSeparators.
	(inputStream peekFor: $*)
		ifTrue: [
			handler hasOptionalArgument
				ifTrue: [self errorUnboundedArgumentAfterOptional].
			handler handleUnboundedArgument: anArgument]
		ifFalse: [
			(inputStream peekFor: $?)
				ifTrue: [handler handleOptionalArgument: anArgument]
				ifFalse: [
					handler hasOptionalArgument
						ifTrue: [self errorNonOptionalArgumentAfterOptional].
					handler handleArgument: anArgument]]! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:37'!
nextReturnType
	inputStream skipSeparators.
	handler handleReturnType: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:26'!
parseInput
	self
		nextReturnType;
		nextFunctionName;
		nextArgumentList! !

XPathParser subclass: #XPathNodeTestParser
	instanceVariableNames: 'context'
	classVariableNames: 'NodeTypeTestParserSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParser commentStamp: 'monty 2/10/2015 02:56' prior: 0!
This class parses node tests that are either node name tests like 'name' or '*' or node type tests like 'node()' or 'comment()'.!

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 2/22/2015 01:09'!
initialize 
	"self initialize"

	self initializeNodeTypeTestParserSelectors! !

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 3/2/2015 14:50'!
initializeNodeTypeTestParserSelectors
	(NodeTypeTestParserSelectors := Dictionary new)
		at: 'comment' put: #nextCommentTypeTest;
		at: 'text' put: #nextTextTypeTest;
		at: 'processing-instruction' put: #nextPITypeTest;
		at: 'node' put: #nextAnyNodeTypeTest;
		at: 'element' put: #nextElementTypeTest;
		at: 'attribute' put: #nextAttributeTypeTest;
		at: 'namespace' put: #nextNamespaceTypeTest! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 08:44'!
nextAnyNodeTypeTest
	self nextEndArgumentList.
	context handleTestForAnyNodeTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/27/2015 05:48'!
nextAttributeTypeTest
	context := XPathAttributeTypeNodeTestParserContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/27/2015 13:46'!
nextCommentTypeTest
	self nextEndArgumentList.
	context handleTestForCommentTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/27/2015 05:48'!
nextElementTypeTest
	context := XPathElementTypeNodeTestParserContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/22/2015 11:26'!
nextEmptyTest
	context handleEmptyTestWith: handler! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 04:51'!
nextNamespaceTypeTest
	self nextEndArgumentList.
	context handleTestForNamespaceTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/5/2015 08:15'!
nextPITypeTest
	| name |

	inputStream skipSeparators.
	name :=
		(self nextStringLiteralOptional: true)
			ifNil: [self nextNCNameOptional: true].
	name
		ifNil: [context handleTestForPITypeWith: handler]
		ifNotNil: [
			context
				handleTestForPIWithName: name
				with: handler].
	self nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 11:11'!
nextTextTypeTest
	self nextEndArgumentList.
	context handleTestForTextTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 08:42'!
parseInput
	context := XPathInitialNodeTestParserContext new.
	self peekForNodeTest.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/26/2015 15:04'!
peekForExpandedNameTest: aName
	(aName = 'Q'
		and: [inputStream peekFor: ${])
		ifTrue: [| uri localName |
			uri := self expectUpTo: $}.
			localName := self nextNCName.
			context
				handleTestForNamespaceURI: uri
				localName: localName
				with: handler.
			^ true]
		ifFalse: [^ false]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/3/2015 17:40'!
peekForNameTestOrNoteTypeTest: aLocalName
	inputStream skipSeparators.
	(inputStream peekFor: $:)
		ifTrue: [^ false]. ": after spaces; axis specifier"

	(context isTypeTestParserContext not
		and: [self peekForStartArgumentList])
		ifTrue: [^ self peekForNodeTypeTest: aLocalName]
		ifFalse: [
			context
				handleTestForName: aLocalName
				with: handler.
			^ true].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/3/2015 17:39'!
peekForNameTestStartingWith: anNcName
	(inputStream peekFor: $:)
		ifTrue: [
			inputStream peek == $: ":: axis specifier"
				ifTrue: [^ false]
				ifFalse: [^ self peekForQualifiedNameTestWithPrefix: anNcName]]
		ifFalse: [
			^ (self peekForExpandedNameTest: anNcName)
				or: [self peekForNameTestOrNoteTypeTest: anNcName]]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 04:54'!
peekForNodeTest
	inputStream skipSeparators.
	(inputStream atEnd not
		and: [self peekForWildCardNameTest
			or: [self peekForNonWildCardNameTest]])
		ifTrue: [^ true]
		ifFalse: [
			self nextEmptyTest.
			^ false]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 03:56'!
peekForNodeTypeTest: aNodeTypeOrFunctionName
	self perform:
		(NodeTypeTestParserSelectors
			at: aNodeTypeOrFunctionName
			ifAbsent: [^ false]).
	^ true.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/28/2015 14:29'!
peekForNonWildCardNameTest
	| startPosition ncName |

	startPosition := inputStream position.
	((ncName := self nextNCNameOptional: true) notNil
		and: [self peekForNameTestStartingWith: ncName])
		ifTrue: [^ true]
		ifFalse: [
			ncName
				ifNotNil: [
					inputStream
						pushBackNCName: ncName
						position: startPosition].
			^ false].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 11:42'!
peekForQualifiedNameTestWithPrefix: aPrefix
	(inputStream peekFor: $*)
		ifTrue: [
			context
				handleTestForPrefix: aPrefix
				with: handler.
			^ true]
		ifFalse: [| localName |
			localName := self nextNCName.
			self peekForStartArgumentList "function"
				ifTrue: [^ false]
				ifFalse: [
					context
						handleTestForPrefix: aPrefix
						localName: localName
						with: handler.
					^ true]].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/27/2015 05:24'!
peekForStartArgumentList
	inputStream skipSeparators.
	^ inputStream peekFor: $(.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 11:46'!
peekForWildCardNameTest
	(inputStream peekFor: $*)
		ifFalse: [^ false].

	(inputStream peekFor: $:)
		ifTrue: [
			(inputStream peekFor: $*)
				ifTrue: [context handleTestForAnyNameWith: handler]
				ifFalse: [
					context
						handleTestForLocalName: self nextNCName
						with: handler]]
		ifFalse: [context handleTestForAnyNameWith: handler].
	^ true.! !

!XPathParser class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 06:01'!
on: aStringOrStream for: aHandler
	^ self new
		on: aStringOrStream
		for: aHandler! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:27'!
endParsing
	handler handleEndParsing.
	handler mustBeAtEndAfterParsing
		ifTrue: [	
			inputStream skipSeparators.
			inputStream atEnd
				ifFalse: [self errorExpectedAtEnd]].! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpected: aString
	XPathSyntaxException
		formatSignal: 'Expected {1}'
		with: aString! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:53'!
errorExpectedAtEnd
	self errorExpected: 'end of input'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpectedLiteral: anExpectedCharacterOrString butGot: aReceivedCharacterOrString
	XPathSyntaxException
		formatSignal: 'Expected "{1}" but got "{2}"'
		with: anExpectedCharacterOrString
		with: (aReceivedCharacterOrString ifNil: [''])! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/8/2015 05:57'!
errorExpectedName
	self errorExpected: 'name'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/8/2015 05:57'!
errorExpectedRelativeLocationPath
	self errorExpected: 'relative location path'! !

!XPathParser methodsFor: 'private' stamp: 'monty 3/10/2015 19:48'!
errorExpectedStringLiteral
	self errorExpected: 'single or double quoted string literal'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/18/2015 14:06'!
expectNext: aCharacter
	| nextChar |

	((nextChar := inputStream next) == aCharacter)
		ifFalse: [
			self
				errorExpectedLiteral: aCharacter
				butGot: nextChar].
	^ aCharacter.! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/10/2015 08:58'!
expectUpTo: aCharacter
	writeStream reset.
	[inputStream atEnd
		or: [inputStream peek == aCharacter]]
		whileFalse: [writeStream nextPut: inputStream next].
	self expectNext: aCharacter.
	^ writeStream contents.! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
handler
	^ handler! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
inputStream
	^ inputStream! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/15/2015 22:25'!
nextArgument
	"override to parse arguments in function argument lists"! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:26'!
nextArgumentList
	"a template method; nextArgument must be overriden to handle arguments"
	self nextStartArgumentList.
	self peekForEndArgumentList
		ifFalse: [
			self nextArgument.
			[self peekForArgumentSeparator]
				whileTrue: [self nextArgument].
			self nextEndArgumentList].! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:20'!
nextEmptyArgumentList
	self
		nextStartArgumentList;
		nextEndArgumentList
! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextEndArgumentList
	inputStream skipSeparators.
	self expectNext: $).! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 03:46'!
nextNCName
	^ self nextNCNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/15/2015 11:10'!
nextNCNameOptional: aBoolean
	(inputStream hasPushedBackToken
		and: [inputStream pushedBackToken isNCNameToken])
		ifTrue: [^ inputStream nextPushedBackToken].

	writeStream reset.
	(XMLWellFormedParserTokenizer
		nextNCNameFrom: inputStream
		on: writeStream)
		ifFalse: [
			aBoolean
				ifTrue: [^ nil]
				ifFalse: [self errorExpectedName]].
	^ writeStream contents.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/2/2015 04:40'!
nextName
	^ self nextNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/2/2015 04:41'!
nextNameOptional: aBoolean
	inputStream hasPushedBackToken
		ifTrue: [
			inputStream pushedBackToken isNCNameToken
				ifTrue: [
					writeStream
						reset;
						nextPutAll: inputStream nextPushedBackToken.
					(inputStream peekFor: $:)
						ifTrue: [
							writeStream
								nextPut: $:;
								nextPutAll:
									((self nextNCNameOptional: aBoolean)
										ifNil: [^ nil])].
					^ writeStream contents]].

	writeStream reset.
	(XMLWellFormedParserTokenizer
		nextNameFrom: inputStream
		on: writeStream)
			ifFalse: [
			aBoolean
				ifTrue: [^ nil]
				ifFalse: [self errorExpectedName]].
	^ writeStream contents.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextStartArgumentList
	inputStream skipSeparators.
	self expectNext: $(.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 03:42'!
nextStringLiteral
	^ self nextStringLiteralOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:47'!
nextStringLiteralOptional: aBoolean
	(inputStream peek == $"
		or: [inputStream peek == $'])
		ifTrue: [^ self expectUpTo: inputStream next]
		ifFalse: [
			aBoolean
				ifFalse: [self errorExpectedStringLiteral].
			^ nil]! !

!XPathParser methodsFor: 'initialization' stamp: 'monty 1/14/2015 03:22'!
on: aStringOrStream for: aHandler
	inputStream :=
		(aStringOrStream isStream
			ifTrue: [aStringOrStream asXPathReadStreamAdapter]
			ifFalse: [aStringOrStream readStream asXPathReadStreamAdapter]).
	handler := aHandler.
	writeStream := (String new: 32) writeStream.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 06:07'!
parse
	[self
		startParsing;
		parseInput;
		endParsing]
		on: XPathException
		do: [:error |
			error
				appendPosition: inputStream position;
				pass].
	^ handler parsingResult.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 06:06'!
parseInput
	self subclassResponsibility! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 3/10/2015 19:13'!
peekForArgumentSeparator
	inputStream skipSeparators.
	^ inputStream peekFor: $,! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 3/10/2015 19:15'!
peekForEndArgumentList
	inputStream skipSeparators.
	^ inputStream peekFor: $)! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:59'!
startParsing
	handler handleStartParsing! !

Object subclass: #XPathParserHandler
	instanceVariableNames: 'parsingResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParserHandler commentStamp: 'monty 1/10/2015 01:54' prior: 0!
An abstract class for XPath parser handlers.!

XPathParserHandler subclass: #XPathExpressionParserHandler
	instanceVariableNames: 'outputStream variableIndex contextNodeVariable contextPositionVariable contextSizeVariable'
	classVariableNames: 'AxisSpecifierNamesAndSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParserHandler commentStamp: 'monty 2/10/2015 02:55' prior: 0!
A handler for XPath expression parsers that generates Smalltalk source implementing the XPath expression.!

!XPathExpressionParserHandler class methodsFor: 'private' stamp: 'monty 2/10/2015 22:19'!
axisSpecifierNameAndSelectorPairs
	^ #(
		'ancestor' '%%'
		'ancestor-or-self' '%%~'
		'attribute' '@'
		'child' '/'
		'descendant' '//'
		'descendant-or-self' '//~'
		'following' '>>'
		'following-sibling' '>>>'
		'namespace' '@@'
		'parent' '%'
		'preceding' '<<'
		'preceding-sibling' '<<<'
		'self' '~'
		'%%' '%%'
		'%%~' '%%~'
		'@' '@'
		'>>' '>>'
		'>>>' '>>>'
		'@@' '@@'
		'%' '%'
		'<<' '<<'
		'<<<' '<<<'
		'~' '~'
		)! !

!XPathExpressionParserHandler class methodsFor: 'class initialization' stamp: 'monty 2/10/2015 22:19'!
initialize
	"self initialize"

	self initializeAxisSpecifierNamesAndSelectors! !

!XPathExpressionParserHandler class methodsFor: 'class initialization' stamp: 'monty 2/10/2015 22:19'!
initializeAxisSpecifierNamesAndSelectors
	AxisSpecifierNamesAndSelectors := Dictionary new.
	self axisSpecifierNameAndSelectorPairs
		pairsDo: [:axisSpecifier :selector |
			AxisSpecifierNamesAndSelectors
				at: axisSpecifier asString
				put: selector asString].! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/12/2015 05:53'!
decrementVariableNames
	variableIndex := variableIndex - 1.
	self generateVariableNames.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitBooleanConversion
	outputStream nextPutAll: ' asXPathBoolean'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/10/2015 22:14'!
emitEndAttributePredicate
	outputStream nextPutAll: ']]'.
	self emitEndPredicateBlock.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitEndBlock
	outputStream nextPut: $]! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitEndGrouping
	outputStream nextPut: $)! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:26'!
emitEndPredicateBlock
	self decrementVariableNames.
	outputStream nextPut: $].! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:15'!
emitQuotedString: aString
	outputStream nextPut: $'.
	"escape ' by outputting another ' before it"
	1 to: aString size do: [:i | | nextChar |
		(nextChar := aString at: i) == $'
			ifTrue: [outputStream nextPut: $'].
		outputStream nextPut: nextChar].
	outputStream nextPut: $'.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:34'!
emitStartAttributePredicate: aName
	self emitStartPredicateBlock.
	outputStream
		nextPutAll: contextNodeVariable;
		nextPutAll: ' isElement and:[';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' hasAttributes and:[(';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' attributeAt:'.
	self emitQuotedString: aName.
	outputStream nextPut: $).! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 3/26/2015 22:43'!
emitStartContextBlock
	outputStream
		nextPutAll: '[:';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' :c| |';
		nextPutAll: contextPositionVariable;
		space;
		nextPutAll: contextSizeVariable;
		nextPut: $|! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitStartGrouping
	outputStream nextPut: $(! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 3/26/2015 21:06'!
emitStartPredicateBlock
	self incrementVariableNames.
	outputStream
		nextPutAll: '??[:';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' :';
		nextPutAll: contextPositionVariable;
		nextPutAll: ' :';
		nextPutAll: contextSizeVariable;
		nextPut: $|.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:11'!
errorUnrecognizedAxisSpecifier: anAxisSpecifier
	XPathSyntaxException
		formatSignal: 'Unrecognized axis specifier "{1}"'
		with: anAxisSpecifier! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 3/26/2015 21:09'!
generateVariableNames
	| indexString |

	indexString := variableIndex printString.
	contextNodeVariable := indexString copyWithFirst: $n.
	contextPositionVariable := indexString copyWithFirst: $p.
	contextSizeVariable := indexString copyWithFirst: $s.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleAddition
	outputStream nextPutAll: '//+'! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/10/2015 22:18'!
handleAxisSpecifier: anAxisSpecifier
	outputStream nextPutAll:
		(AxisSpecifierNamesAndSelectors
			at: anAxisSpecifier
			ifAbsent: [self errorUnrecognizedAxisSpecifier: anAxisSpecifier])! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:52'!
handleDivision
	outputStream nextPutAll: '///'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:21'!
handleEndAdditiveExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:47'!
handleEndAndExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:55'!
handleEndEqualityExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:58'!
handleEndFunctionArgument
	outputStream nextPutAll: ');'! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:57'!
handleEndFunctionCall
	outputStream nextPutAll: 'invoke)'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:55'!
handleEndMultiplicativeExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:27'!
handleEndOrExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/11/2015 10:05'!
handleEndParsing
	self
		emitEndBlock;
		parsingResult: outputStream contents! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/13/2015 11:23'!
handleEndPathExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:26'!
handleEndPredicate
	self emitEndPredicateBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:47'!
handleEndRelationalExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:05'!
handleEndShortCircuitAnd
	self
		emitBooleanConversion;
		emitEndBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:05'!
handleEndShortCircuitOr
	self
		emitBooleanConversion;
		emitEndBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/11/2015 00:11'!
handleEndShortCircuited: anInteger
	anInteger > 0
		ifTrue: [
			self emitBooleanConversion.
			anInteger timesRepeat: [self emitEndBlock]]! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/14/2015 03:54'!
handleEndUnaryExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:08'!
handleEndUnionExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleEquals
	outputStream nextPutAll: '//='! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleGreaterThan
	outputStream nextPutAll: '//>'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleGreaterThanOrEqualTo
	outputStream nextPutAll: '//>='! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 3/26/2015 22:33'!
handleIntegerPredicate: anIntegerString
	outputStream
		nextPutAll: '??';
		nextPutAll: anIntegerString! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 3/26/2015 22:12'!
handleLastFunctionCall
	outputStream
		nextPut: $(;
		nextPutAll: contextSizeVariable;
		nextPutAll: ' ifNil:[';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' defaultContextSize])'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleLessThan
	outputStream nextPutAll: '//<'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:11'!
handleLessThanOrEqualTo
	outputStream nextPutAll: '//<='! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:11'!
handleModulus
	outputStream nextPutAll: '//\\'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:11'!
handleMultiplication
	outputStream nextPutAll: '//*'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:10'!
handleNegation
	outputStream nextPutAll: '-1//*'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:10'!
handleNotEquals
	outputStream nextPutAll: '//!!='! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/11/2015 12:13'!
handleNumberLiteral: anIntegerOrFloatString
	outputStream
		space;
		nextPutAll: anIntegerOrFloatString! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 3/26/2015 22:13'!
handlePositionFunctionCall
	outputStream
		nextPut: $(;
		nextPutAll: contextPositionVariable;
		nextPutAll: ' ifNil:[';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' defaultContextPosition])'! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:33'!
handlePredicateAttribute: aName equalsStringLiteral: aStringLiteral
	self emitStartAttributePredicate: aName.
	outputStream nextPut: $=.
	self
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate.! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:33'!
handlePredicateAttribute: aName notEqualsStringLiteral: aStringLiteral
	self emitStartAttributePredicate: aName.
	outputStream nextPutAll: '~='.
	self
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate.! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/4/2015 06:45'!
handleStartAbsoluteLocationPath
	outputStream
		nextPutAll: contextNodeVariable;
		nextPutAll: ' documentRoot'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:21'!
handleStartAdditiveExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:47'!
handleStartAndExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:45'!
handleStartEqualityExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:58'!
handleStartFunctionArgument
	outputStream nextPutAll: 'push: ('! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/12/2015 06:01'!
handleStartFunctionCall: aFunctionName
	outputStream
		nextPutAll: '((c function: ''';
		nextPutAll: aFunctionName;
		nextPutAll: ''' contextNode: ';
		nextPutAll: contextNodeVariable;
		nextPut: $)! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:04'!
handleStartMultiplicativeExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:27'!
handleStartOrExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/12/2015 05:56'!
handleStartParsing
	outputStream := (String new: 128) writeStream.
	variableIndex := 1.
	self
		generateVariableNames;
		emitStartContextBlock.! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/13/2015 11:23'!
handleStartPathExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:25'!
handleStartPredicate
	self emitStartPredicateBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:47'!
handleStartRelationalExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/14/2015 02:44'!
handleStartRelativeLocationPath
	outputStream nextPutAll: contextNodeVariable! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:16'!
handleStartShortCircuitAnd
	self emitBooleanConversion.
	outputStream nextPutAll: ' and:['.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:16'!
handleStartShortCircuitOr
	self emitBooleanConversion.
	outputStream nextPutAll: ' or:['.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/14/2015 03:54'!
handleStartUnaryExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:08'!
handleStartUnionExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/20/2015 11:15'!
handleStringLiteral: aString
	self emitQuotedString: aString! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:10'!
handleSubtraction
	outputStream nextPutAll: '//-'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/14/2015 04:30'!
handleTestForAnyName
	outputStream nextPutAll: '[:n|n isPrincipalNode]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	outputStream nextPutAll: '[:n|true]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	outputStream nextPutAll: '[:n|n isAttribute]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 13:55'!
handleTestForAttributeWithLocalName: aLocalName
	outputStream
		nextPutAll: '[:n|n isAttribute and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 14:04'!
handleTestForAttributeWithName: aName
	outputStream
		nextPutAll: '[:n|n isAttribute and:[n name=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	outputStream
		nextPutAll: '[:n|n isAttribute and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: '''and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:05'!
handleTestForAttributeWithPrefix: aPrefix
	outputStream
		nextPutAll: '(c testForAttributeWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/2/2015 13:35'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	outputStream
		nextPutAll: '(c testForAttributeWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: '''localName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	outputStream nextPutAll: '[:n|n isComment]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	outputStream nextPutAll: '[:n|n isElement]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:11'!
handleTestForElementWithLocalName: aLocalName
	outputStream
		nextPutAll: '[:n|n isElement and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:10'!
handleTestForElementWithName: aName
	outputStream
		nextPutAll: '[:n|n isElement and:[n name=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	outputStream
		nextPutAll: '[:n|n isElement and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: '''and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:05'!
handleTestForElementWithPrefix: aPrefix
	outputStream
		nextPutAll: '(c testForElementWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/2/2015 13:35'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	outputStream
		nextPutAll: '(c testForElementWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: '''localName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 11:03'!
handleTestForLocalName: aLocalName
	outputStream
		nextPutAll: '[:n|n isPrincipalNode and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/25/2015 21:44'!
handleTestForName: aName
	outputStream
		nextPutAll: '[:n|n isPrincipalNode and:[n name=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 04:32'!
handleTestForNamespaceType
	outputStream nextPutAll: '[:n|n isNamespace]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/22/2015 02:52'!
handleTestForNamespaceURI: aURI localName: aLocalName
	outputStream
		nextPutAll: '[:n|n isPrincipalNode and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: '''and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 08:50'!
handleTestForPIType
	outputStream nextPutAll: '[:n|n isPI]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	outputStream
		nextPutAll: '[:n|n isPI and:[n target=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 15:51'!
handleTestForPrefix: aPrefix
	outputStream
		nextPutAll: '(c testForPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/15/2015 03:26'!
handleTestForPrefix: aPrefix localName: aLocalName
	outputStream
		nextPutAll: '(c testForPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: '''localName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	outputStream nextPutAll: '[:n|n isStringNode]'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/13/2015 11:06'!
handleUnion
	outputStream nextPut: $|! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/17/2015 04:50'!
handleVariableReference: aName
	outputStream
		nextPutAll: '(c variableAt: ''';
		nextPutAll: aName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/12/2015 05:52'!
incrementVariableNames
	variableIndex := variableIndex + 1.
	self generateVariableNames.! !

XPathParserHandler subclass: #XPathFunctionPrototypeParserHandler
	instanceVariableNames: 'function returnType functionName minArguments maxArguments argumentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

XPathFunctionPrototypeParserHandler class
	instanceVariableNames: 'classesByTypeName'!

!XPathFunctionPrototypeParserHandler commentStamp: 'monty 2/10/2015 20:39' prior: 0!
A handler for function prototype parsers that initializes an XPathFunction class with the function name, return type, and number and types of arguments specified by the prototype.!

XPathFunctionPrototypeParserHandler class
	instanceVariableNames: 'classesByTypeName'!

!XPathFunctionPrototypeParserHandler class methodsFor: 'private' stamp: 'monty 1/23/2015 19:48'!
classesByTypeName
	^ classesByTypeName
		ifNil: [
			(classesByTypeName := Dictionary new)
				at: 'object' put: Object;
				at: 'boolean' put: Boolean;
				at: 'string' put: String;
				at: 'number' put: Number;
				at: 'node-set' put: XPathNodeSet;
				yourself]! !

!XPathFunctionPrototypeParserHandler class methodsFor: 'private' stamp: 'monty 1/23/2015 19:47'!
classesByTypeNameAt: aTypeName ifAbsent: aBlock
	^ self classesByTypeName
		at: aTypeName
		ifAbsent: aBlock! !

!XPathFunctionPrototypeParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/9/2015 07:12'!
function: aFunction
	^ self new setFunction: aFunction! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/9/2015 07:34'!
addArgumentTypeFor: aTypeName
	argumentTypes addLast: (self classForTypeName: aTypeName)! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/23/2015 12:42'!
classForTypeName: aTypeName
	^ self class
		classesByTypeNameAt: aTypeName
		ifAbsent: [self errorUnrecognizedTypeName: aTypeName]! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/9/2015 07:14'!
errorUnrecognizedTypeName: aTypeName
	XPathTypeException
		formatSignal: 'Unrecognized type name "{1}"'
		with: aTypeName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleArgument: anArgument
	minArguments := minArguments + 1.
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:19'!
handleEndParsing
	function
		setReturnType: returnType
		functionName: functionName
		minArguments: minArguments
		maxArguments: maxArguments
		argumentTypes: argumentTypes! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:17'!
handleFunctionName: aName
	functionName := aName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleOptionalArgument: anArgument
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:15'!
handleReturnType: aReturnType
	returnType := self classForTypeName: aReturnType! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:32'!
handleUnboundedArgument: anArgument
	maxArguments := nil.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'testing' stamp: 'monty 1/9/2015 07:26'!
hasOptionalArgument
	^ minArguments < maxArguments
	! !

!XPathFunctionPrototypeParserHandler methodsFor: 'testing' stamp: 'monty 1/9/2015 07:27'!
hasUnboundedArgument
	^ maxArguments isNil! !

!XPathFunctionPrototypeParserHandler methodsFor: 'initialization' stamp: 'monty 1/9/2015 07:11'!
setFunction: aFunction
	function := aFunction.
	maxArguments := 0.
	minArguments := 0.
	argumentTypes := OrderedCollection new.! !

XPathParserHandler subclass: #XPathNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserHandler commentStamp: 'monty 1/10/2015 01:22' prior: 0!
An abstract handler for node test parsers.!

XPathNodeTestParserHandler subclass: #XPathExpressionNodeTestParserHandler
	instanceVariableNames: 'currentAxis expressionParserHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionNodeTestParserHandler commentStamp: 'monty 2/10/2015 20:39' prior: 0!
A handler used by the expression parser for parsing node tests that are part of location path steps.!

!XPathExpressionNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/13/2015 11:43'!
currentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	^ self new
		setCurrentAxis: anAxis
		expressionParserHandler: anExpressionParserHandler! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/21/2015 18:30'!
handleEmptyTest
	self parsingResult: false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/13/2015 12:42'!
handleStartParsing
	self parsingResult: false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 04:29'!
handleTestForAnyName
	self startNodeTest.
	expressionParserHandler handleTestForAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	self startNodeTest.
	expressionParserHandler handleTestForAnyNodeType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:00'!
handleTestForAttributeWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:51'!
handleTestForAttributeWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForAttributeWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:52'!
handleTestForAttributeWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:50'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForAttributeWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	self startNodeTest.
	expressionParserHandler handleTestForCommentType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:42'!
handleTestForElementWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:42'!
handleTestForElementWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForElementWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:43'!
handleTestForElementWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForElementWithPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:43'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForElementWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/25/2015 21:44'!
handleTestForName: aName
	self startNodeTest.
	expressionParserHandler handleTestForName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 04:33'!
handleTestForNamespaceType
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:50'!
handleTestForPIType
	self startNodeTest.
	expressionParserHandler handleTestForPIType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForPIWithName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:23'!
handleTestForPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	self startNodeTest.
	expressionParserHandler handleTestForTextType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'initialization' stamp: 'monty 1/13/2015 11:43'!
setCurrentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	currentAxis := anAxis.
	expressionParserHandler := anExpressionParserHandler.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'private' stamp: 'monty 1/14/2015 04:26'!
startNodeTest
	self parsingResult: true.
	currentAxis handleWith: expressionParserHandler.! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:51'!
handleEmptyTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:59'!
handleTestForAttributeWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:19'!
handleTestForAttributeWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:19'!
handleTestForAttributeWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/28/2015 14:16'!
handleTestForName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:59'!
handleTestForNamespaceType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:50'!
handleTestForPIType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:53'!
handleTestForPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType! !

XPathNodeTestParserHandler subclass: #XPathStringNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathStringNodeTestParserHandler commentStamp: 'monty 2/10/2015 02:54' prior: 0!
A handler for node tests that occur in string arguments to the abbreviated axis selectors. It converts them to node test blocks.!

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/2/2015 13:28'!
handleEmptyTest
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node name isEmpty]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyName
	self parsingResult: [:node | node isPrincipalNode]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	self parsingResult: [:node | true]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	self parsingResult: [:node | node isAttribute]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:00'!
handleTestForAttributeWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:20'!
handleTestForAttributeWithName: aName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:18'!
handleTestForAttributeWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isAttribute
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isAttribute
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	self parsingResult: [:node | node isComment]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	self parsingResult: [:node | node isElement]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isElement
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithName: aName
	self parsingResult:
		[:node |
			node isElement
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isElement
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isElement
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isElement
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/2/2015 16:01'!
handleTestForLocalName: aLocalName
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/25/2015 21:44'!
handleTestForName: aName
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 14:00'!
handleTestForNamespaceType
	self parsingResult: [:node | node isNamespace]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:51'!
handleTestForPIType
	self parsingResult: [:node | node isPI]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	self parsingResult:
		[:node |
			node isPI
				and: [node target = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForPrefix: aPrefix
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:21'!
handleTestForPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	self parsingResult: [:node | node isStringNode]! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleEndParsing! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleStartParsing! !

!XPathParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ true! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 1/10/2015 06:10'!
parsingResult
	^ parsingResult! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 3/14/2015 14:00'!
parsingResult: aParsingResult
	"set value to be returned by #parse"

	parsingResult := aParsingResult! !

Object subclass: #XPathPushedBackToken
	instanceVariableNames: 'token position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackToken commentStamp: 'monty 1/15/2015 11:06' prior: 0!
This is a class for storing pushed-back tokens so they can be quickly read again.!

XPathPushedBackToken subclass: #XPathPushedBackNCNameToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackNCNameToken commentStamp: 'monty 1/10/2015 01:22' prior: 0!
A pushed-back non-qualified name token, to be read by nextNCName.!

!XPathPushedBackNCNameToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:21'!
isNCNameToken
	^ true! !

!XPathPushedBackToken class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 07:21'!
token: aToken position: aPosition
	^ self new
		setToken: aToken
		position: aPosition! !

!XPathPushedBackToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:19'!
isNCNameToken
	^ false! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:18'!
position
	^ position! !

!XPathPushedBackToken methodsFor: 'initialization' stamp: 'monty 1/8/2015 07:22'!
setToken: aToken position: aPosition
	token := aToken.
	position := aPosition.! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/14/2015 15:07'!
token
	^ token! !

Object subclass: #XPathReadStreamAdapter
	instanceVariableNames: 'stream pushedBackToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathReadStreamAdapter commentStamp: 'monty 2/10/2015 03:03' prior: 0!
This class is an adapter for positionable read streams that wraps them to be safe to send messages like next and peek when atEnd and supports efficient push back using token objects.!

!XPathReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 02:51'!
on: aStream
	^ self new on: aStream! !

!XPathReadStreamAdapter methodsFor: 'converting' stamp: 'monty 1/14/2015 03:19'!
asXPathReadStreamAdapter
	^ self! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/8/2015 02:50'!
atEnd
	^ stream atEnd! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/9/2015 08:02'!
hasPushedBackToken
	^ pushedBackToken notNil
		and: [pushedBackToken position = self position]! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/10/2015 01:20'!
isStream
	^ true! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
next
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream next]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/10/2015 02:29'!
nextPushedBackToken
	| token |

	token := pushedBackToken token.
	self position: self position + token size.
	pushedBackToken := nil.
	^ token.! !

!XPathReadStreamAdapter methodsFor: 'initialization' stamp: 'monty 1/8/2015 02:52'!
on: aStream
	stream := aStream! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
peek
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream peek]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/10/2015 02:29'!
peekFor: aCharacter
	(stream atEnd not
		and: [stream peek == aCharacter])
		ifTrue: [
			stream next.
			^ true]
		ifFalse: [^ false]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:10'!
peekForAll: aString
	| oldPosition |

	(stream atEnd not
		and: [stream peek == (aString at: 1)])
		ifFalse: [^ false].

	oldPosition := stream position.
	stream next.
	2 to: aString size do: [:i |
		(stream atEnd not
			and: [stream next == (aString at: i)])
			ifFalse: [
				stream position: oldPosition.
				^ false]].
	^ true.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position
	^ stream position! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position: aPosition
	stream position: aPosition! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/26/2015 14:34'!
pushBackNCName: anNcName position: aPosition
	self pushBackToken:
		(XPathPushedBackNCNameToken
			token: anNcName
			position: aPosition)! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/9/2015 11:33'!
pushBackToken: aPushedBackToken
	pushedBackToken := aPushedBackToken.
	self position: aPushedBackToken position.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:03'!
pushedBackToken
	^ pushedBackToken! !

!XPathReadStreamAdapter methodsFor: 'streaming' stamp: 'monty 1/19/2015 13:51'!
skipBack
	"does not peek like #back"
	stream position: stream position - 1! !

!XPathReadStreamAdapter methodsFor: 'streaming' stamp: 'monty 1/8/2015 07:38'!
skipSeparators
	stream skipSeparators! !

Object subclass: #XPathSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

XPathSortOrder class
	instanceVariableNames: 'instance'!

!XPathSortOrder commentStamp: 'monty 3/7/2015 10:25' prior: 0!
Abstract class for node sort orders. Instances are immutable and shared.!

XPathSortOrder class
	instanceVariableNames: 'instance'!

XPathSortOrder subclass: #XPathDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathDocumentSortOrder commentStamp: 'monty 2/10/2015 03:47' prior: 0!
A sort order for nodes in document order.!

!XPathDocumentSortOrder methodsFor: 'converting' stamp: 'monty 1/26/2015 20:29'!
asDocumentSortOrder
	^ self! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet do: aBlock! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 3/19/2015 05:13'!
documentOrderOn: aNodeSet indexOfNextParentAfterIndex: anIndex
	anIndex + 1 to: aNodeSet size do: [:i |
		(aNodeSet at: i) hasChildren
			ifTrue: [^ i]].
	^ nil.! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 1/30/2015 17:12'!
documentOrderSort: aNodeSet
	"already in document order"! !

!XPathDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet first! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:29'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet reverseDo: aBlock! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 2/5/2015 06:31'!
reverseDocumentOrderSort: aNodeSet
	aNodeSet
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new! !

XPathDocumentSortOrder subclass: #XPathElementMetaNodeDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathElementMetaNodeDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for attribute or namespace nodes in document order.!

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:33'!
attributeAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:37'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:37'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:34'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	"has no descendants"
	^ self
		selfAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:33'!
namespaceAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:39'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

XPathDocumentSortOrder subclass: #XPathLevelDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for nodes in document order all having the same parent, or the children of nodes having the same parent, and so on.!

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderChildAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

XPathSortOrder subclass: #XPathReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathReverseDocumentSortOrder commentStamp: 'monty 2/10/2015 01:28' prior: 0!
A sort order for node in reverse document order.!

XPathReverseDocumentSortOrder subclass: #XPathLevelReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelReverseDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for nodes in reverse document order all having the same parent, or the children of nodes having the same parent, and so on.!

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderChildAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 1/30/2015 19:18'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet reverseDo: aBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 3/19/2015 19:55'!
documentOrderOn: aNodeSet indexOfNextParentAfterIndex: anIndex
	| firstIndex |

	firstIndex :=
		anIndex > 0
			ifTrue: [anIndex]
			ifFalse: [aNodeSet size + 1].
	firstIndex - 1 to: 1 by: -1 do: [:i |
		(aNodeSet at: i) hasChildren
			ifTrue: [^ i]].
	^ nil.! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 2/3/2015 01:32'!
documentOrderSort: aNodeSet
	aNodeSet
		reverseInPlace;
		sortOrder: XPathDocumentSortOrder new! !

!XPathReverseDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet last! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet do: aBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 2/5/2015 06:30'!
reverseDocumentOrderSort: aNodeSet! !

!XPathSortOrder class methodsFor: 'instance creation' stamp: 'monty 3/7/2015 10:26'!
new
	"these classes are immutable and shared, so they are only initialized once"
	^ instance ifNil: [instance := self basicNew initialize]! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/19/2015 21:25'!
ancestorAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	"copy will contain the list of ancestors in document order which is then
	reversed to get a list of ancestors in reverse document order"
	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | oldSize |
		oldSize := copy size.
		self
			ancestorsOfNode: each
			select: aNodeTestBlock
			into: copy.

		"ancestors are added in reverse document order, so if more than one was
		added, reverse them in place to keep copy in document order"
		(copy size - oldSize) > 1
			ifTrue: [
				copy
					reverseInPlaceFrom: oldSize + 1
					to: copy size]].

	^ copy
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/19/2015 21:29'!
ancestorOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	"copy will contain the list of nodes and ancestors in document order which
	is then reversed to get a list of nodes and ancestors in reverse document order"
	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | oldSize |
		oldSize := copy size.
		(copy includes: each)
			ifFalse: [
				(aNodeTestBlock value: each)
					ifTrue: [copy addLast: each].
				self
					ancestorsOfNode: each
					select: aNodeTestBlock
					into: copy].

		"nodes and ancestors are added in reverse document order, so if more
		than one was added, reverse them in place to keep copy in document order"
		(copy size - oldSize) > 1
			ifTrue: [
				copy
					reverseInPlaceFrom: oldSize + 1
					to: copy size]].

	^ copy
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/19/2015 21:25'!
ancestorsOfNode: aNode select: aNodeTestBlock into: aNodeSet
	aNode ancestorNodesDo: [:each |
		(aNodeSet includes: each)
			ifTrue: [^ self].
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]]! !

!XPathSortOrder methodsFor: 'converting' stamp: 'monty 1/26/2015 20:28'!
asDocumentSortOrder
	^ XPathDocumentSortOrder new! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/10/2015 01:04'!
attributeAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(each isElement
			and: [each hasAttributes])
			ifTrue: [
				each attributeNodesDo: [:attribute |
					(aNodeTestBlock value: attribute)
						ifTrue: [copy addLast: attribute]]]].
	^ copy sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/19/2015 15:38'!
childAxisOn: aNodeSet select: aNodeTestBlock
	| copy nextParentIndex |

	copy := aNodeSet copyEmpty.
	nextParentIndex :=
		self
			documentOrderOn: aNodeSet
			indexOfNextParentAfterIndex: 0.
	[nextParentIndex isNil]
		whileFalse: [
			nextParentIndex :=
				self
					childrenOfNodeAt: nextParentIndex
					from: aNodeSet
					select: aNodeTestBlock
					into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/25/2015 06:43'!
childrenOfNodeAt: anIndex from: anOldNodeSet select: aNodeTestBlock into: aNewNodeSet
	| parent indexOfNextParent ancestorOfNextChildren |

	parent := anOldNodeSet at: anIndex.
	(indexOfNextParent :=
		self
			documentOrderOn: anOldNodeSet
			indexOfNextParentAfterIndex: anIndex)
		ifNotNil: [
			ancestorOfNextChildren :=
				(anOldNodeSet at: indexOfNextParent)
					ancestorOrSelfChildOfParent: parent].

	parent nodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNewNodeSet addLast: each].
		(ancestorOfNextChildren notNil
			and: [each = ancestorOfNextChildren])
			ifTrue: [
				(indexOfNextParent :=
					self
						childrenOfNodeAt: indexOfNextParent
						from: anOldNodeSet
						select: aNodeTestBlock
						into: aNewNodeSet)
					ifNil: [ancestorOfNextChildren := nil]
					ifNotNil: [
						ancestorOfNextChildren :=
							(anOldNodeSet at: indexOfNextParent)
								ancestorOrSelfChildOfParent: parent]]].

	^ indexOfNextParent.! !

!XPathSortOrder methodsFor: 'copying' stamp: 'monty 3/7/2015 10:25'!
copy
	"instances are immutable and shared"
	^ self! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/19/2015 21:31'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		self
			descendantsOfNode: each
			select: aNodeTestBlock
			into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/19/2015 21:35'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				(aNodeTestBlock value: each)
					ifTrue: [copy addLast: each].
				self
					descendantsOfNode: each
					select: aNodeTestBlock
					into: copy]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/19/2015 21:31'!
descendantsOfNode: aNode select: aNodeTestBlock into: aNodeSet
	aNode descendentNodesDo: [:each |
		(aNodeSet includes: each)
			ifTrue: [^ self].
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]]! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
documentOrderOn: aNodeSet do: aBlock
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 1/26/2015 18:43'!
documentOrderSort: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrderFrom: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/11/2015 12:09'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each followingNodesDo: [:followingNode |
					(aNodeTestBlock value: followingNode)
						ifTrue: [copy addLast: followingNode]]]].
	^ copy sort.
! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/8/2015 02:58'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each followingSiblingNodesDo: [:sibling |
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]]]].
	^ copy sort.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/4/2015 11:08'!
levelOrderChildAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		each hasChildren
			ifTrue: [
				each nodesDo: [:node |
					(aNodeTestBlock value: node)
						ifTrue: [copy addLast: node]]]].
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/4/2015 11:07'!
levelOrderFollowingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each followingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/4/2015 11:07'!
levelOrderFollowingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each followingSiblingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/4/2015 11:07'!
levelOrderPrecedingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each precedingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/4/2015 11:08'!
levelOrderPrecedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each precedingSiblingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathLevelReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/10/2015 01:04'!
namespaceAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(each isElement
			and: [each hasNamespaceNodes])
			ifTrue: [
				each namespaceNodesDo: [:namespace |
					(aNodeTestBlock value: namespace)
						ifTrue: [copy addLast: namespace]]]].
	^ copy sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/19/2015 22:37'!
parentAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	"parent axis is a forward axis, according to spec"
	self documentOrderOn: aNodeSet do: [:each | | parent |
		(each hasParent
			and: [(copy includes: (parent := each parent)) not
				and: [aNodeTestBlock value: parent]])
			ifTrue: [copy addLast: parent]].
	^ copy sortOrder: self asDocumentSortOrder.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/11/2015 12:19'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each precedingNodesDo: [:precedingNode |
					(aNodeTestBlock value: precedingNode)
						ifTrue: [copy addLast: precedingNode]]]].
	^ copy reverseSort.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/11/2015 12:19'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each precedingSiblingNodesDo: [:sibling |
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]]]].
	^ copy reverseSort.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:27'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 2/5/2015 06:30'!
reverseDocumentOrderSort: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/1/2015 01:44'!
selfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [copy addLast: each]].
	^ copy sortOrder: self asDocumentSortOrder.! !

XPathSortOrder subclass: #XPathUnknownSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathUnknownSortOrder commentStamp: 'monty 2/10/2015 03:49' prior: 0!
A sort order for unsorted nodes or nodes in an unknown sort order.!

!XPathUnknownSortOrder methodsFor: 'enumerating' stamp: 'monty 3/19/2015 15:54'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ self asDocumentSortOrder
		childAxisOn: aNodeSet sorted
		select: aNodeTestBlock! !

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 1/30/2015 19:19'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet sorted do: aBlock! !

!XPathUnknownSortOrder methodsFor: 'sorting' stamp: 'monty 2/3/2015 03:48'!
documentOrderSort: aNodeSet
	aNodeSet
		sort: [:a :b | a = b or: [a occursInDocumentBeforeNode: b]];
		sortOrder: XPathDocumentSortOrder new! !

!XPathUnknownSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet sorted first! !

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 3/15/2015 22:14'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet reverseSorted do: aBlock! !

!XPathUnknownSortOrder methodsFor: 'sorting' stamp: 'monty 2/10/2015 21:39'!
reverseDocumentOrderSort: aNodeSet
	aNodeSet
		sort: [:a :b | b occursInDocumentBeforeNode: a];
		sortOrder: XPathReverseDocumentSortOrder new! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/13/2015 23:08'!
/ aNodeTestStringOrBlock
	"child axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self hasChildren
		ifTrue: [
			self nodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathLevelDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/13/2015 23:08'!
// aNodeTestStringOrBlock
	"descendant axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self descendentNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/13/2015 23:08'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self allNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"spec says the string-value of documents and elements is all text
	descendants concatenated, so contentString can't be used because it
	inserts spaces"
	^ self rawContentString! !
XPathNodeTestParser initialize!
XPathExpressionParserHandler initialize!
XPathContext initialize!
XPath initialize!
XPathExpressionParser initialize!
